/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   FileOp.cpp
 * Author: sjg
 * 该类用于所有的文件操作
 * Created on 2016年11月1日, 上午9:08
 */
#include <sys/types.h>
#include <dirent.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <string.h>
#include "FileOp.h"
#include "dataTypeDef.h"
#include "globalFunc.h"
#include "StrategyParam.h"
#include "SocketOp.h"
#include <fstream>
#include <sstream>
int globalVariable = 0; // 初始化全局变量
FileOp::FileOp() {
}

FileOp::FileOp(const FileOp& orig) {
}

FileOp::~FileOp() {
}
bool fileExists1(const std::string& filename) {
    std::ifstream file(filename);
    return file.good();
} 

    static std::ofstream* ofOutput;

    // 初始化特定于进程的输出文件
    void FileOp::initOutputFile() {
        // 获取当前进程的ID
      //  pid_t pid = getpid();
             string FaPId= to_string(getpid());
     string filename = FileOp::g_OutputPath + "/" + FileOp::JudgeFileFullNameNoExt + ".out";
       // std::string filename=  FileOp::g_OutputPath + "/" + FileOp::JudgeFileFullNameNoExt +"_C2"+pid+".out";
      
      //  ss << "output_" << pid << ".txt"; // 构建文件名，格式为output_PID.txt
      //  std::string filename = ss.str();

        // 实例化ofstream对象
        ofOutput = new std::ofstream(filename);

        if (!ofOutput->is_open()) { // 检查文件是否成功打开
            // 错误处理
            std::cerr << "Failed to open output file for PID " << FaPId<< std::endl;
        }
    }
string FileOp::homePath;//得到系统的主目录
string FileOp::strategyFile;//得到自动模式运行的策略文件
int FileOp::strategyFileSize = 0;
int FileOp::strategyMode;//得到自动模式
int FileOp::runMode;//运行模式

UINT32 FileOp::runFileId = 0;//run文件编号,保证每个run文件存放40个R
UINT32 FileOp::outPutRCount = 0;//记录输出多少个三角形
string FileOp::judgeOriginalFileFullName;//original file
string FileOp::judgeOriginalFileName;//original file name
string FileOp::JudgeFileFullName; //判定文件完整名称（路径+后缀）
string FileOp::JudgeFileName; //判定文件名（有后缀）
string FileOp::JudgeFileFullNameNoExt; //无后缀判定文件完整名称
string FileOp::JudgeFileDir;	  //判定文件所在路径
string FileOp::JudgeFileResult;//存放验证文件对应的判断结果
FILETYPE FileOp::fileType = MYDefine;//判断文件初始为MYDefine
ofstream *FileOp::ofJudgeFileResult;//存放验证文件对应的文件指针
ofstream *FileOp::ofJudgeAllFileResult;//存放所有验证文件对应的文件指针

ofstream *FileOp::ofSingleEndUnitCla = NULL;
ofstream *FileOp::ofNouseCla = NULL;
vector<string> FileOp::StrategyfileName;
//DIR* FileOp::dir = nullptr;

string FileOp::g_FileDir = "";	  //判定文件所在路径
string FileOp::g_WorkDir = "";	//后台数据输出路径
string FileOp::g_PreFileFullName = ""; //预处理文件		  //D:\ProverOutPut\RUNINFO\SX4\1.pre
string FileOp::g_OutputPath = "";//运行日志存放完整路径
string FileOp::appPath = "";//应用程序路径
string FileOp::workSpace = "";//工作路径
    

   
ofstream* FileOp::ofRealInfoOut = NULL;	//实际输出流
ofstream* FileOp::ofLogOut = NULL;		//日志输出流
ofstream* FileOp::ofPathOut = NULL;

ofstream* FileOp::ofPathOutFork = NULL;

ofstream* FileOp::ofOutput = nullptr;
ofstream* FileOp::ofProofComp = nullptr;
ofstream* FileOp::strategyRecord = nullptr;

INT32 FileOp::runFileNum = 0;

void FileOp::getTopPath(bool useVersion){
    if(useVersion){
        char* path;
        path = getenv("HOME");
        string pathGet(path);
        homePath = pathGet;
        strategyFile= appPath + "/strategy";
    }
    else {
        char* path;
        path = getenv("HOME");
        string pathGet(path);
        homePath = pathGet;
        strategyFile= homePath + "/Desktop/strategy";
    }
}
RESULT FileOp::AnalysisFileName(string FilePath)
{
    size_t pos = FilePath.find_last_of('/');
    if (pos == -1)
        return READERR;
    else {
        JudgeFileFullName = FilePath;//判断文件的绝对路径
        JudgeFileDir = FilePath.substr(0, pos);//判断文件的存放路径
        JudgeFileName = FilePath.substr(pos + 1);//判断文件名
        size_t posEnd = JudgeFileName.find_last_of('.');
        JudgeFileFullNameNoExt = JudgeFileName.substr(0, posEnd); //判断文件（不含格式名）
        string suffix=JudgeFileName.substr(posEnd+1);//判断文件的格式
        //设置文件类型
        if (suffix == "tptp" || suffix == "TPTP") {
            fileType = TPTP;
        } else if (suffix == "fof" || suffix == "FOF") {
            fileType = FOF;
        } else {
            fileType = MYDefine;
        }
        JudgeFileResult =homePath + "/Desktop/output";//输出文件存放文件夹
        if(StrategyParam::orForCompition)
            JudgeFileResult = FileOp::workSpace;
        //初始化输出路径
        g_WorkDir =homePath + "/Desktop/output";//工作路径
         if(StrategyParam::orForCompition)
            g_WorkDir = FileOp::workSpace;
        g_OutputPath = g_WorkDir + "/" + JudgeFileFullNameNoExt;//判断文件的输出文件夹
        g_PreFileFullName = g_WorkDir + "/" + JudgeFileFullNameNoExt + ".pre";//判断文件的预处理文件名
        if (!isExistDir(g_OutputPath))
            return ERR_OUTFOLDER;
        if (!CreateLogFile())
            return ERR_OUTFOLDER;
        if(StrategyParam::orForCompition)
            CreateTotalOutputFile(false);
        return READOK;
    }
}
//创建判定文件输出路径
void FileOp::CreateResultFile()
{
    string strLogPath = FileOp::JudgeFileResult+ "/" + FileOp::JudgeFileFullNameNoExt + ".log";
    
    //cout<<strLogPath<<endl;
    try {
        ofJudgeFileResult = new ofstream(strLogPath.c_str(),ios::out);
        
        //*ofJudgeFileResult<<"I am running"<<endl;
        return;
    } catch (exception* e) {
        cout << "运行信息输出错误" << e->what()<< endl;
    }
}
//bool FileOp::CreateRunInfoFileFork(UINT32 StartId )
//{
//    string runId = to_string(StartId);
//    if(runId.length() == 1){
//        runId = "000" + runId;
//    }
//    else if(runId.length() == 2){
//        runId = "00" + runId;
//    }
//    else if(runId.length() == 3){
//        runId = "0" + runId;
//    }
//    string strOutRunPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + "_C" + runId + "_F1.run";
//    string strPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + "_C" + runId + "_F1.path";
//    
//    try {
//        if(ofRealInfoOutFork){
//            if(ofRealInfoOutFork->is_open()) {
//                ofRealInfoOutFork->close();
//                ofRealInfoOutFork = nullptr; 
//            }
//        }
//        if(ofPathOutFork) {
//            if (ofPathOutFork->is_open()) {
//                ofPathOutFork->close();
//                ofPathOutFork = nullptr;
//            }
//        }
//        
//        ofRealInfoOutFork = new ofstream(strOutRunPath, ios::app);
//        //*ofRealInfoOut<<"从编号为"+to_string(StartId)+"子句开始构建三角形"<<endl;
//        ofPathOutFork = new ofstream(strPath, ios::app);
//        return true;
//    } catch (exception* e) {
//        //string errInfo = e->what();
//        //printlo(errInfo);
//        return false;
//    }
//}
bool FileOp::CreateRunInfoFileFork(UINT32 StartId, UINT32 PID )
{
    string runId = to_string(PID)+"P"+to_string(StartId);//to_string(StartId);
    if(runId.length() == 1){
        runId = "000" + runId;
    }
    else if(runId.length() == 2){
        runId = "00" + runId;
    }
    else if(runId.length() == 3){
        runId = "0" + runId;
    }
    string strOutRunPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + "_C" + runId + "_F1.run";
    string strPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + "_C" + runId + "_F1.path";
    
    try {
        if(ofRealInfoOut){
            if(ofRealInfoOut->is_open()) {
                ofRealInfoOut->close();
                ofRealInfoOut = nullptr; 
            }
        }
        if(ofPathOut) {
            if (ofPathOut->is_open()) {
                ofPathOut->close();
                ofPathOut = nullptr;
            }
        }
        
        ofRealInfoOut = new ofstream(strOutRunPath, ios::app);
        //*ofRealInfoOut<<"从编号为"+to_string(StartId)+"子句开始构建三角形"<<endl;
        ofPathOut = new ofstream(strPath, ios::app);
        return true;
    } catch (exception* e) {
        //string errInfo = e->what();
        //printlo(errInfo);
        return false;
    }
}

//bool FileOp::CreateRunInfoFileFork(UINT32 StartId )
//{
//    string runId = to_string(StartId);//to_string(StartId);
//    if(runId.length() == 1){
//        runId = "000" + runId;
//    }
//    else if(runId.length() == 2){
//        runId = "00" + runId;
//    }
//    else if(runId.length() == 3){
//        runId = "0" + runId;
//    }
//    string strOutRunPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + "_C" + runId + "_F1.run";
//    string strPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + "_C" + runId + "_F1.path";
//    
//    try {
//        if(ofRealInfoOut){
//            if(ofRealInfoOut->is_open()) {
//                ofRealInfoOut->close();
//                ofRealInfoOut = nullptr; 
//            }
//        }
//        if(ofPathOut) {
//            if (ofPathOut->is_open()) {
//                ofPathOut->close();
//                ofPathOut = nullptr;
//            }
//        }
//        
//        ofRealInfoOut = new ofstream(strOutRunPath, ios::app);
//        //*ofRealInfoOut<<"从编号为"+to_string(StartId)+"子句开始构建三角形"<<endl;
//        ofPathOut = new ofstream(strPath, ios::app);
//        return true;
//    } catch (exception* e) {
//        //string errInfo = e->what();
//        //printlo(errInfo);
//        return false;
//    }
//}

bool FileOp::CreateRunInfoFile(UINT32 StartId )
{
    string runId = to_string(StartId);
    if(runId.length() == 1){
        runId = "000" + runId;
    }
    else if(runId.length() == 2){
        runId = "00" + runId;
    }
    else if(runId.length() == 3){
        runId = "0" + runId;
    }
    string strOutRunPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + "_C" + runId + "_P1.run";
    string strPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + "_C" + runId + "_P1.path";
    
    try {
        if(ofRealInfoOut){
            if(ofRealInfoOut->is_open()) {
                ofRealInfoOut->close();
                ofRealInfoOut = nullptr; 
            }
        }
        if(ofPathOut) {
            if (ofPathOut->is_open()) {
                ofPathOut->close();
                ofPathOut = nullptr;
            }
        }
        
        ofRealInfoOut = new ofstream(strOutRunPath, ios::app);
        //*ofRealInfoOut<<"从编号为"+to_string(StartId)+"子句开始构建三角形"<<endl;
        ofPathOut = new ofstream(strPath, ios::app);
        return true;
    } catch (exception* e) {
        //string errInfo = e->what();
        //printlo(errInfo);
        return false;
    }
}
bool FileOp::delCreateRunInfoFile(UINT32 StartId )
{
    string runId = to_string(StartId);
    if(runId.length() == 1){
        runId = "000" + runId;
    }
    else if(runId.length() == 2){
        runId = "00" + runId;
    }
    else if(runId.length() == 3){
        runId = "0" + runId;
    }
    string strOutRunPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + "_C" + runId + "_P1.run";
    string strPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + "_C" + runId + "_P1.path";
    
    try {
        FILE* fp;
        char ch;
        if((fp = fopen(strOutRunPath.c_str(),"r")) != NULL){
            fseek(fp,0,SEEK_SET);
            ch = fgetc(fp);
            if(ch == EOF){
                fclose(fp);
                remove(strOutRunPath.c_str());
            }
            else
                fclose(fp);
        }
        if((fp = fopen(strPath.c_str(),"r")) != NULL){
            fseek(fp,0,SEEK_SET);
            ch = fgetc(fp);
            if(ch == EOF){
                fclose(fp);
                remove(strPath.c_str());
            }
            else
                fclose(fp);
        }
        return true;
    } catch (exception* e) {
        //string errInfo = e->what();
        //printlo(errInfo);
        return false;
    }
}
//输出预处理的演绎路径
bool FileOp::CreateRunInfoFilePre(UINT32 StartId )
{
    string strOutRunPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + "_C" + to_string(StartId) + "_Pre.run";
    string strPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + "_C" + to_string(StartId) + "_Pre.path";
    
    try {
        ofRealInfoOut = new ofstream(strOutRunPath, ios::app);
        //*ofRealInfoOut<<"从编号为"+to_string(StartId)+"子句开始构建三角形"<<endl;
        ofPathOut = new ofstream(strPath, ios::app);
        return true;
    } catch (exception* e) {
        //string errInfo = e->what();
        //printlo(errInfo);
        return false;
    }
}

//输出归结路径strLogPath 存放日志信息，strLog存放判定结果统计
bool FileOp::CreateLogFile()
{
    string strLogPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".log";
    string strLog = homePath + "/Desktop/proofRes.txt";
    if(StrategyParam::orForCompition)
        strLog = FileOp::appPath + "/proofRes.txt";
    try {
        ofLogOut = new ofstream(strLogPath, ios::out);
        ofJudgeAllFileResult = new ofstream(strLog.c_str(),ios::app);
        return true;
    } catch (exception* e) {
        //string errInfo = e->what();
        //PrintErr(errInfo);
        return false;
    }
}

//输出归结路径strLogPath 存放日志信息，strLog存放判定结果统计
bool FileOp::CreateTotalOutputFile(bool parseTime)
{
    if(parseTime){
        JudgeFileResult = FileOp::workSpace;
        g_OutputPath = FileOp::workSpace;
    }
       string FaPId= to_string(getpid());
        string strOutput = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".out";
   //  string strOutput = g_OutputPath + "/" + JudgeFileFullNameNoExt +"_C1"+FaPId+ ".out";
    //g_OutputPath + "/" + JudgeFileFullNameNoExt + "_C" + runId + "_P1.run";
   // string strOutput = g_OutputPath + "/" + JudgeFileFullNameNoExt/* +"_C" + to_string(getpid())*/+ ".out";//zgy
    //string strProofComp = JudgeFileResult + "/proofStatistics.txt";
    try {
        ofOutput = new ofstream(strOutput, ios::out);
        //ofProofComp = new ofstream(strProofComp.c_str(),ios::app);
        return true;
    } catch (exception* e) {
        //string errInfo = e->what();
        //PrintErr(errInfo);
        return false;
    }
}

//输入文件完整路径包括文件名，输出文件路径（不包括文件名）
string FileOp::getFilePath(string &fileFullName)
{
    size_t pos = fileFullName.find_last_of('/');
    if (pos == -1)
        return fileFullName;
    return fileFullName.substr(0, pos);
}
//获取带后缀的文件名
string FileOp::getFileName(string &fileFullName)
{
    size_t pos = fileFullName.find_last_of('/');
    if (pos == -1)
        return fileFullName;
    return fileFullName.substr(pos + 1);
}
//获取不带扩展名的文件名
string FileOp::getFileNameNoExt(string fileFullName)
{
    size_t posBeg = fileFullName.find_last_of('/');
    size_t posEnd = fileFullName.find_last_of('.');
    if (posEnd == -1)
        return fileFullName.substr(posBeg + 1);
    return fileFullName.substr(posBeg + 1, posEnd - posBeg);
}
//释放三角形输出的文件流

void FileOp::outReleaseOf(){
    if (ofRealInfoOut) {
        ofRealInfoOut->close();
        ofRealInfoOut = NULL;
    }
    if (ofPathOut) {
        ofPathOut->close();
        ofPathOut = NULL;
    }
}
//释放文件读取流
void FileOp::ReleaseOf()
{
    if (ofRealInfoOut) {
        ofRealInfoOut->close();
        ofRealInfoOut = NULL;
    }
    if (ofLogOut) {
        ofLogOut->close();
        ofLogOut = NULL;
    }
    if (ofPathOut) {
        ofPathOut->close();
        ofPathOut = NULL;
    }
    if (ofJudgeAllFileResult) {
        ofJudgeAllFileResult->close();
        ofJudgeAllFileResult = NULL;
    }
    if (StrategyParam::orForCompition) {
        if (ofOutput) {
            ofOutput->close();
            ofOutput = NULL;
        }
        if (ofProofComp) {
            ofProofComp->close();
            ofProofComp = NULL;
        }
    }
    FileOp::StrategyfileName.clear();
    vector<string>().swap(FileOp::StrategyfileName);
//    if(dir)
//        closedir(dir);
}
//20170315 输出最后的单元子句



void FileOp::PrintINFOEndRSinglePre(string& msg)
{
    //输出FOL  ofJudgeAllFileResult = new ofstream(strLog.c_str(),ios::app);
    
//    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".erspre";
//    ofSingleEndUnitCla = new ofstream(strInfoPath, ios::out);
//    *ofSingleEndUnitCla << msg << endl;
//    ofSingleEndUnitCla->flush();
//    ofSingleEndUnitCla->close();
    
    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".res";
//    int fd = open(strInfoPath.c_str(),O_RDWR|O_CREAT,0664);
//    if( fd == -1){
//        printf("message:%s\n",strerror(errno));
//        return;
//    }
//    else{
//        write(fd,msg.c_str(),strlen(msg.c_str()));
//        close(fd);
//    }
    ofstream ofInfoStream(strInfoPath, ios::out);
    //if(ofInfoStream.is_open()){
//        ofInfoStream <<"_532_"<< msg << endl;
         *resFileid()<<msg << endl;
              if(1){
         int n=0;
char ch;
if(!ofInfoStream.eof()){

 string outid=FileOp::g_OutputPath + "/"  +FileOp::JudgeFileFullNameNoExt+"process_" + std::to_string(getppid()) + ".resid";
       if(fileExists1(outid)){
          
    std::string cmdFileOut3 = "cat " + outid+ " > " + strInfoPath;
     int res3 = system(const_cast<char*> (cmdFileOut3.c_str()));
//     ofInfoStream<<cmdFileOut3 <<endl;
       }
}
     }
        ofInfoStream.close();
        
        if(1){
          string strInfoPath1 = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".out";  
           ofstream ofInfoStream1(strInfoPath1, ios::out);
              if(1){
         int n=0;
char ch;
if(!ofInfoStream1.eof()){

 string outid1=FileOp::g_OutputPath + "/"  +FileOp::JudgeFileFullNameNoExt+"process_" + std::to_string(getppid()) + ".outid";
       if(fileExists1(outid1)){
          
    std::string cmdFileOut31 = "cat " + outid1+ " > " + strInfoPath1;
     int res31 = system(const_cast<char*> (cmdFileOut31.c_str()));
//     ofInfoStream<<cmdFileOut3 <<endl;
       }
}
     }
        ofInfoStream1.close();
        
        }
        
   // }
//    else{
//        char* clauseSet = strtok(msg.c_str(),"\n");
//        FILE* fp;
//        fp = fopen(strInfoPath.c_str(),"w+");
//        if(fp != nullptr){
//            fputs(msg.c_str(),fp);
//        }
//        fclose(fp);
//    }
    
}

//20170315 输出Valid
void FileOp::PrintValid(const string& msg)
{
    //输出FOL  ofJudgeAllFileResult = new ofstream(strLog.c_str(),ios::app);
    
//    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".erspre";
//    ofSingleEndUnitCla = new ofstream(strInfoPath, ios::out);
//    *ofSingleEndUnitCla << msg << endl;
//    ofSingleEndUnitCla->flush();
//    ofSingleEndUnitCla->close();
    
    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".validID";
//    int fd = open(strInfoPath.c_str(),O_RDWR|O_CREAT,0664);
//    if( fd == -1){
//        printf("message:%s\n",strerror(errno));
//        return;
//    }
//    else{
//        write(fd,msg.c_str(),strlen(msg.c_str()));
//        close(fd);
//    }
    ofstream ofInfoStream(strInfoPath, ios::app);
    //if(ofInfoStream.is_open()){
        ofInfoStream << msg << endl;
        ofInfoStream.close();
   // }
//    else{
//        char* clauseSet = strtok(msg.c_str(),"\n");
//        FILE* fp;
//        fp = fopen(strInfoPath.c_str(),"w+");
//        if(fp != nullptr){
//            fputs(msg.c_str(),fp);
//        }
//        fclose(fp);
//    }
    
}


//20170315 输出最后的单元子句
void FileOp::prinfResForE(string& msg)
{
    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".res";
    ofstream ofInfoStream(strInfoPath, ios::app);
//    ofInfoStream <<"_592_"<< msg << endl;
     *resFileid()<<msg << endl;
                if(1){
         int n=0;
char ch;
if(!ofInfoStream.eof()){

 string outid=FileOp::g_OutputPath + "/"  +FileOp::JudgeFileFullNameNoExt+"process_" + std::to_string(getppid()) + ".resid";
       if(fileExists1(outid)){
          
    std::string cmdFileOut3 = "cat " + outid+ " > " + strInfoPath;
     int res3 = system(const_cast<char*> (cmdFileOut3.c_str()));
//     ofInfoStream<<cmdFileOut3 <<endl;
       }
}
     }
    ofInfoStream.close(); 
    
    if(1){
          string strInfoPath1 = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".out";  
           ofstream ofInfoStream1(strInfoPath1, ios::out);
              if(1){
         int n=0;
char ch;
if(!ofInfoStream1.eof()){

 string outid1=FileOp::g_OutputPath + "/"  +FileOp::JudgeFileFullNameNoExt+"process_" + std::to_string(getppid()) + ".outid";
       if(fileExists1(outid1)){
          
    std::string cmdFileOut31 = "cat " + outid1+ " > " + strInfoPath1;
     int res31 = system(const_cast<char*> (cmdFileOut31.c_str()));
//     ofInfoStream<<cmdFileOut3 <<endl;
       }
}
     }
        ofInfoStream1.close();
    }
}

void FileOp::prinfPreResForE(string& msg)
{
    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".res";
    ofstream ofInfoStream(strInfoPath, ios::app);
//    ofInfoStream << "_601_"<<msg;
     *resFileid()<<msg << endl;
                if(1){
         int n=0;
char ch;
if(!ofInfoStream.eof()){

 string outid=FileOp::g_OutputPath + "/"  +FileOp::JudgeFileFullNameNoExt+"process_" + std::to_string(getppid()) + ".resid";
       if(fileExists1(outid)){
          
    std::string cmdFileOut3 = "cat " + outid+ " > " + strInfoPath;
     int res3 = system(const_cast<char*> (cmdFileOut3.c_str()));
//     ofInfoStream<<cmdFileOut3 <<endl;
       }
}
     }
    ofInfoStream.close(); 
    if(1){
          string strInfoPath1 = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".out";  
           ofstream ofInfoStream1(strInfoPath1, ios::out);
              if(1){
         int n=0;
char ch;
if(!ofInfoStream1.eof()){

 string outid1=FileOp::g_OutputPath + "/"  +FileOp::JudgeFileFullNameNoExt+"process_" + std::to_string(getppid()) + ".outid";
       if(fileExists1(outid1)){
          
    std::string cmdFileOut31 = "cat " + outid1+ " > " + strInfoPath1;
     int res31 = system(const_cast<char*> (cmdFileOut31.c_str()));
//     ofInfoStream<<cmdFileOut3 <<endl;
       }
}
     }
        ofInfoStream1.close();
    }
}

void FileOp::PrintINFOEndRSinglePreNoUse(string& msg)
{
    //输出FOL  ofJudgeAllFileResult = new ofstream(strLog.c_str(),ios::app);
    
//    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".erspre";
//    ofSingleEndUnitCla = new ofstream(strInfoPath, ios::out);
//    *ofSingleEndUnitCla << msg << endl;
//    ofSingleEndUnitCla->flush();
//    ofSingleEndUnitCla->close();
    
    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".nouse";
    ofstream ofInfoStream(strInfoPath, ios::out);
    ofInfoStream << msg << endl;
    ofInfoStream.close();
}
void FileOp::PrintINFONoUsePre(string& msg)
{
    //输出FOL
//    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".nousepre";
//    ofNouseCla = new ofstream(strInfoPath, ios::out);
//    *ofNouseCla << msg << endl;
//    ofNouseCla->flush();
//    ofNouseCla->close();
    
    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".nousepre";
    ofstream ofInfoStream(strInfoPath, ios::out);
    ofInfoStream << msg << endl;
    ofInfoStream.close();
}

RESULT FileOp::FilePathAnaysis(const string& fileFullName)
{
    
}

//判定文件\目录是否存在,若创建失败则返回false
bool FileOp::isExistDir(string strDir)
{
    DIR *mydir = NULL;
    if((mydir = opendir(strDir.c_str()))==NULL)
    {
        int ret = mkdir(strDir.c_str(),0777);
        if(ret != 0)
        {
            cout<<"mkdir fail\n";
            return false;
        }
        else
            return true;
    }
    else{
        closedir(mydir);
        return true;
    }
}

bool FileOp::isExistProof(string strDir)
{
//    DIR *mydir = NULL;
//    if((mydir = opendir(strDir.c_str()))==NULL)
//    {
//        return false;
//    }
//    else{
//        closedir(mydir);
//        return true;
//    }
    struct dirent* ptr;
    //if(dir == nullptr)
    DIR* dir = opendir(g_OutputPath.c_str());
    if(dir == nullptr){
        return false;
    }
    rewinddir(dir);
    while ((ptr = readdir(dir)) != NULL) {
        string name(ptr->d_name);
        string fileName = g_OutputPath + "/" + name;
        size_t posEnd = name.find_last_of(".");
        string suffix = name.substr(posEnd + 1);
        if (suffix == "path" || suffix == "run") {
            name = "";
            fileName = "";
            closedir(dir);
            return true;
        }        
        name = "";
        fileName = "";
    }
    closedir(dir);
    return false;
}


void FileOp::LogOut(const string& msg)
{
    if (!ofLogOut)
        CreateLogFile();
    try {
        *ofLogOut << msg << endl;
    } catch (exception* e) {
        string errInfo = e->what();
        *ofLogOut << errInfo << endl;
    }
}

void FileOp::PrintINFO(string& msg)
{
    //输出FOL
    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".info";
    ofstream ofInfoStream(strInfoPath, ios::app);
    ofInfoStream << msg << endl;
    ofInfoStream.close();
}

void FileOp::PrintINFORPre(string& msg)
{
    //输出FOL
    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".rpre";
    ofstream ofInfoStream(strInfoPath, ios::out);
    ofInfoStream << msg << endl;
    ofInfoStream.close();
}

void FileOp::PrintINFORPreAfter(string& msg)
{
    //输出FOL
    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".rapre";
    ofstream ofInfoStream(strInfoPath, ios::out);
    ofInfoStream << msg << endl;
    ofInfoStream.close();
}

void FileOp::PrintINFORSinglePre(string& msg)
{
    //输出FOL
    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".rspre";
    ofstream ofInfoStream(strInfoPath, ios::out);
    ofInfoStream << msg << endl;
    ofInfoStream.close();
}

void FileOp::PrintINFORSinglePreAfter(string& msg)
{
    //输出FOL
    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".raspre";
    ofstream ofInfoStream(strInfoPath, ios::out);
    ofInfoStream << msg << endl;
    ofInfoStream.close();
}
void FileOp::WritePreFile(const string& str)
{
    //输出预处理后文件
    ofstream ofInfoStream(g_PreFileFullName, ios::out);
    ofInfoStream << str << endl;
    ofInfoStream.close();
}

void FileOp::RInvaildInfoOut(string& rundMsg, INT32 StartId)
{
    try {
        if (!ofRealInfoOut)
            CreateRunInfoFile(StartId);
        *ofRealInfoOut << rundMsg << endl;
        *ofPathOut << rundMsg << endl;
        ofRealInfoOut->flush();
    } catch (exception* e) {
        *ofRealInfoOut << "R冗余信息输出错误！" << e->what() << endl;
    }
}
void FileOp::RInvaildInfoOutPath(string& rundMsg, INT32 StartId)
{
    try {
        if (!ofPathOut)
            CreateRunInfoFile(StartId);
        //*ofRealInfoOut << rundMsg << endl;
        *ofPathOut << rundMsg << endl;
        ofPathOut->flush();
    } catch (exception* e) {
        *ofPathOut << "R冗余信息输出错误！" << e->what() << endl;
    }
}



//输出运行时记录-.run
void FileOp::RunInfoOut(vector<Literal*>& vOptTri, Clause* newCla, INT32 StartId, vector<string>* strOptTris)
{
    // 获取当前进程的 ID
    int pid = getpid();
std::string path = FileOp::g_OutputPath + "/" + FileOp::JudgeFileFullNameNoExt ;//"/full/path/to/your/directory";
    // 创建一个包含进程 ID 的字符串
    std::stringstream filename;
    filename <<path<< "process_" << pid << ".logID";

    // 打开一个新的文件进行写入
    std::ofstream file(filename.str());
    
     // 检查文件是否成功打开
    if(!file.is_open()) {
        std::cerr << "Failed to open log file for process " << pid << '\n';
       // return;
    }

    // 将进程 ID 写入文件
	try {
             
//               bool pidsvalue=true;
//    if(pidsvalue){
//
//    pidsvalue=false;
//    }
        if (!ofRealInfoOut)
            CreateRunInfoFile(StartId);
        string strTmpMsg_P;
        vector<Literal*>::iterator vLitIt;
        for (vLitIt = vOptTri.begin(); vLitIt < vOptTri.end(); ++vLitIt) {
            if (strOptTris) {
                strOptTris->push_back( to_string(getpid())+"805?"+"[C" + to_string((*vLitIt)->Row()) + "_" + to_string((*vLitIt)->Col()) + "]" + (*vLitIt)->subTerm->ToString());
                strTmpMsg_P += strOptTris->back() + "\n";
                *ofPathOut << "[C" << (*vLitIt)->Row() << "_" << to_string((*vLitIt)->Col()) << "]-";
                 *logFileid()<<"_810_"<<"[C" << (*vLitIt)->Row() << "_" << to_string((*vLitIt)->Col()) << "]-";
                ++vLitIt;
                strOptTris->push_back( "[C" + to_string((*vLitIt)->Row()) + "_" + to_string((*vLitIt)->Col()) + "]" + (*vLitIt)->subTerm->ToString());
                strTmpMsg_P += strOptTris->back() + "\n";
                *ofPathOut <<"[C" << (*vLitIt)->Row() << "_" << to_string((*vLitIt)->Col()) << "]-";
                 *logFileid()<<"_815_"<<"[C" << (*vLitIt)->Row() << "_" << to_string((*vLitIt)->Col()) << "]-";

            } else {
                strTmpMsg_P +=  to_string(getpid())+"816?"+"[C" + to_string((*vLitIt)->Row()) + "_" + to_string((*vLitIt)->Col()) + "]" + (*vLitIt)->subTerm->ToString() + "\n";
                *ofPathOut <<  "[C" << (*vLitIt)->Row() << "_" << to_string((*vLitIt)->Col()) << "]-";
  *logFileid()<<"_820_"<<"[C" << (*vLitIt)->Row() << "_" << to_string((*vLitIt)->Col()) << "]-";
                ++vLitIt;
                strTmpMsg_P += to_string(getpid())+"820?"+ "[C" + to_string((*vLitIt)->Row()) + "_" + to_string((*vLitIt)->Col()) + "]" + (*vLitIt)->subTerm->ToString() + "\n";
                *ofPathOut <<  "[C" << (*vLitIt)->Row() << "_" << to_string((*vLitIt)->Col()) << "]-";
                 *logFileid()<<"_824_"<<"[C" << (*vLitIt)->Row() << "_" << to_string((*vLitIt)->Col()) << "]-";
            }
        }

        //输出R
        if (newCla) {
            strTmpMsg_P += to_string(getpid())+"823?"+ "R[" + to_string(newCla->uClaId) + "]:";
            
            for (UINT16 i = 0; i < newCla->uLitNum; ++i)/*"("+to_string(r->maxFuncLayer)+")*/ {
                Literal*lit = newCla->LitPtr[i];
                strTmpMsg_P +=  "[" + to_string(lit->ParentLitRow()) + "_" + to_string(lit->ParentLitCol()) + "]" + lit->subTerm->ToString() + "+";
            }
            string strPrint = strTmpMsg_P.erase(strTmpMsg_P.size() - 1);
            *ofRealInfoOut << strPrint;
             *logFileid()<<"_838_"<<strPrint;
        } else {
            strTmpMsg_P += to_string(getpid())+"838?"+ "R:空子句";
            *ofRealInfoOut << strTmpMsg_P << endl;
             *logFileid()<<"_842_"<<strTmpMsg_P << endl;
            ofRealInfoOut->flush();
        }
    } catch (exception* e) {
        *ofRealInfoOut << "运行信息输出错误" << e->what() << endl;
        //ofRealInfoOut.close();
    }
}

void FileOp::WriteTriPath(string& str) {
    if (!ofRealInfoOut) {
        assert(ofRealInfoOut);
        cout << "运行信息输出错误未创建" << endl;
    }
    try {
        *ofRealInfoOut << str << endl;
    } catch (exception* e) {
        cout << "运行信息输出错误" << e->what() << endl;
        //ofRealInfoOut.close();
    }
}

void FileOp::WriteR(Clause* newCla) {
    //输出R
    int rOutSize = 100;
    if((FileOp::strategyMode == 3) ||(FileOp::strategyMode == 4) ){
        rOutSize = 2000;
    }
    else{
        rOutSize = 100;
    }
        
    ++FileOp::outPutRCount;
    if(FileOp::outPutRCount > rOutSize){//100->1000   20190529
        ++FileOp::runFileId;
        FileOp::outPutRCount = 0;
    }
     
    if (newCla) {
        string strPrint = to_string(getpid())+"878?"+"R[" + to_string(newCla->uClaId) + "]:";
        for (UINT16 i = 0; i < newCla->uLitNum; ++i)/*"("+to_string(r->maxFuncLayer)+")*/ {
            Literal*lit = newCla->LitPtr[i];
            strPrint +="[" + to_string(lit->ParentLitRow()) + "_" + to_string(lit->ParentLitCol()) + "]" + lit->subTerm->ToString() + "+";
            //strPrint += "[" + to_string(lit->ParentLitRow()) + "_" + to_string(lit->ParentLitCol()) + "]" + lit->subTerm->ToStringBind() + "+";
            //测试
            //if (lit->isDel)strPrint += "%Del%";
        }
        strPrint = strPrint.erase(strPrint.size() - 1);
        *ofRealInfoOut << strPrint;
         *logFileid() <<strPrint;
    } else {
        *ofRealInfoOut <<  to_string(getpid())+"?889"+"R:空子句" << endl;
         *logFileid() <<  to_string(getpid())+"?889"+"R:空子句" << endl;
              string cmdFileOutvalid = FileOp::g_OutputPath + "/" + FileOp::JudgeFileFullNameNoExt + ".validid1";
             //ofstream* ofInfoStream =new ofstream(cmdFileOutvalid.c_str(),ios::app);//这行代码无法写入内容，最后文件是空的

                 std::ofstream ofInfoStream(cmdFileOutvalid.c_str(), std::ios::app);//发现这个才能写入内容
//ofInfoStream <<"globalVariable9"<<globalVariable;
globalVariable = static_cast<int>(getpid()); // 初始化全局变量
ofInfoStream <<"globalVariable"<<globalVariable;
    }
    ofRealInfoOut->flush();
}
//读取目录的所有的文件夹
void FileOp::OperDir(string src,vector<string>* fileName)
{
    DIR* dir;
    struct dirent* ptr;
    UINT16 i=0;
    dir = opendir(src.c_str());
    if(dir == nullptr){
        return;
    }
    while ((ptr = readdir(dir)) != NULL) {
        string name(ptr->d_name);
        size_t posEnd = name.find_last_of(".");
        string suffix = name.substr(posEnd + 1);
        if (suffix == "tptp" || suffix == "TPTP" || suffix == "txt"|| suffix == "p"|| suffix == "P") {
            fileName->push_back(name);
            //cout<<src + name<<endl;
            if (++i >= 30000)
                break;
        }
    }
    closedir(dir);
}
void FileOp::delRes(){//zgy
    ;
}
//void FileOp::delRes(){
//    //g_OutputPath
//    //DIR* dir;
//    struct dirent* ptr;
//    //if(dir == nullptr)
//    DIR* dir = opendir(g_OutputPath.c_str());
//    if(dir == nullptr){
//        return;
//    }
//    rewinddir(dir);
//    while ((ptr = readdir(dir)) != NULL) {
//        string name(ptr->d_name);
//        
//        size_t posEnd = name.find_last_of(".");
//        string suffix = name.substr(posEnd + 1);
//        
//        if (suffix == "path" || suffix == "run") {
//            size_t signStart = name.find_last_of("_");
//            string preGenStr = name.substr(signStart+1,posEnd);
//            if(preGenStr != "Pre"){
//                string fileName = g_OutputPath + "/" + name;
//                remove(fileName.c_str());
//            }
//        }
//        name = "";
//    }
//    closedir(dir);
//    
//}

//delete run files
//void FileOp::delRunFiles(){
//    ;
//}
void FileOp::delRunFiles(){
    //cout<<"_864File_"<<endl;
    //g_OutputPath
    //DIR* dir;
    struct dirent* ptr;
    //if(dir == nullptr)
    DIR* dir = opendir(g_OutputPath.c_str());
    if(dir == nullptr){
        return;
    }
    rewinddir(dir);
    while ((ptr = readdir(dir)) != NULL) {
        string name(ptr->d_name);
        string fileName = g_OutputPath + "/" + name;
        size_t posEnd = name.find_last_of(".");
        string suffix = name.substr(posEnd + 1);
        if (suffix == "path" || suffix == "run"|| suffix == "txt") {
        //    cout<<"_880_"<<endl;
            remove(fileName.c_str());
            name = "";
            fileName = "";
            continue;
        }        
        name = "";
        fileName = "";
    }
    closedir(dir);
   // cout<<"_890_"<<endl;
}

//删除文件夹所有的文件
void FileOp::delAllFiles(){
    ;
}
//void FileOp::delAllFiles(){
//    //g_OutputPath
//    //DIR* dir;
//    struct dirent* ptr;
//    //if(dir == nullptr)
//    DIR* dir = opendir(g_OutputPath.c_str());
//    if(dir == nullptr){
//        return;
//    }
//    rewinddir(dir);
//    while ((ptr = readdir(dir)) != NULL) {
//        string name(ptr->d_name);
//        string fileName = g_OutputPath + "/" + name;
//        if(StrategyParam::preprocess) {
//            size_t posEnd = name.find_last_of(".");
//            string suffix = name.substr(posEnd + 1);
//            if (suffix == "info" || suffix == "res" || suffix == "log") {
//                name = "";
//                fileName = "";
//                continue;
//            }
//        }
//        else if(StrategyParam::useCombinedSys != 0) {
//            size_t posEnd = name.find_last_of(".");
//            string suffix = name.substr(posEnd + 1);
//             if (suffix == "info" || suffix == "res" || suffix == "run"){
//                 name = "";
//                fileName = "";
//                 continue;
//             }
//        }
//        remove(fileName.c_str());
//        name = "";
//        fileName = "";
//    }
//    closedir(dir);
//}

//删除文件夹所有的文件
void FileOp::delAllFilesComplete(string filePath){
    ;
}
//void FileOp::delAllFilesComplete(string filePath){
//    //g_OutputPath
//    //DIR* dir;
//    struct dirent* ptr;
//    DIR*  dir = opendir(filePath.c_str());
//    if(dir == nullptr){
//        return;
//    }
//    rewinddir(dir);
//    while ((ptr = readdir(dir)) != NULL) {
//        string name(ptr->d_name);
//        string fileName = filePath + "/" + name;
//
//        remove(fileName.c_str());
//        name = "";
//        fileName = "";
//    }
//    closedir(dir);
//}
//whether file is empty
bool FileOp::isFileEmpty(string filePath){
    FILE* fp;
    fp = fopen(filePath.c_str(),"r");
    if(!fp){
        return false;
    }
    char ch=fgetc(fp);
    if(ch==EOF){
        fclose(fp);
        return true;
    }
    else{
        fclose(fp);
        return false;
    }
}


//读取策略文件夹的所有策略
void FileOp::OperStrategy(string src,vector<string>* fileName)
{
    DIR* dir;
    struct dirent* ptr;
    //int i=0;
    dir = opendir(src.c_str());
    if(dir == nullptr){
        return;
    }
    while ((ptr = readdir(dir)) != NULL) {
        string name(ptr->d_name);
        size_t posEnd = name.find_last_of(".");
        string suffix = name.substr(posEnd + 1);
        if ((name.find("strategy") != string::npos) && (suffix == "txt")) {
            fileName->push_back(FileOp::strategyFile + "/" + name);
            //cout<<src + name<<endl;
//            if (++i >= 600)
//                break;
        }
    }
    closedir(dir);
}

int FileOp::strategyFileSizeFunc(string src){
    int size = 0;
    DIR* dir;
    struct dirent* ptr;
    dir = opendir(src.c_str());
    if(dir == nullptr){
        return -1;
    }
    while ((ptr = readdir(dir)) != NULL) {
        string name(ptr->d_name);
        size_t posEnd = name.find_last_of(".");
        string suffix = name.substr(posEnd + 1);
        if ((name.find("strategy") != string::npos) && (suffix == "txt")) {
            ++size;
        }
    }
    closedir(dir);
    return size;
}

bool comp(const string s1, const string s2){
    string s3 = s1.substr(s1.find_last_of("/")+1);
    int begPos1 = s3.find_first_of("strategy") + 8;
    int endPos1 = s3.find_first_of(".");
    int num1 = stoi(s3.substr(begPos1, endPos1 - begPos1));
    string s4 = s2.substr(s2.find_last_of("/")+1);
    int begPos2 = s4.find_first_of("strategy") + 8;
    int endPos2 = s4.find_first_of(".");
    int num2 = stoi(s4.substr(begPos2, endPos2 - begPos2));
    return num1 < num2;
}

//根据下标找到策略的绝对路径
string FileOp::findStrategy(string path, int len)
{
    //vector<string> fileName;
    if(len == 0){
        FileOp::StrategyfileName.clear();
        OperStrategy(path, &FileOp::StrategyfileName);
        sort(FileOp::StrategyfileName.begin(),FileOp::StrategyfileName.end(),comp);
    }
    if((FileOp::StrategyfileName.size() == 0) || (len < 0) || (len >= FileOp::StrategyfileName.size()))
        return nullptr;
    return FileOp::StrategyfileName[len];
}




string FileOp::findStrategyTptp(string path, int len)
{
    //vector<string> fileName;

    FileOp::StrategyfileName.clear();
    OperStrategy(path, &FileOp::StrategyfileName);
//    cout<<"before sort"<<endl;
//    for(int i=0; i<FileOp::StrategyfileName.size();++i)
//        cout<<FileOp::StrategyfileName[i]<<endl;
//    string str1 = "/home/ars01/Desktop/strategy/strategy16.txt";
//    string str2 = "/home/ars01/Desktop/strategy/strategy133.txt";
//    comp(str1,str2);
    
    sort(FileOp::StrategyfileName.begin(), FileOp::StrategyfileName.end(),comp);
    
    if ((FileOp::StrategyfileName.size() == 0) || (len < 0) || (len >= FileOp::StrategyfileName.size()))
        return nullptr;
    return FileOp::StrategyfileName[len];
}

//获取内存信息
//_syscall1(int,sysinfo,struct sysinfo*,info);
long FileOp::getMem()
{
    FILE *fd;
    char buff[256];
    fd = fopen("/proc/meminfo","r");
    if(fd == nullptr){
        return 200000;
    }
    long memFree = 0;
    long cachedFree = 0;
    while((fgets(buff,sizeof(buff),fd)) != NULL)//Cached:
    {
        string strMem(buff);
        if(strMem.find("MemFree") != string::npos)
        {
            int pos = strMem.find("MemFree") + 8;
            strMem = strMem.substr(pos);
            TrimStr(strMem);
            pos = strMem.find(" ");
            strMem = strMem.substr(0,pos);
            memFree = atol(strMem.c_str());
        }
        else if((strMem.find("Cached") != string::npos) && (strMem.find("SwapCached") == string::npos))
        {
            int pos = strMem.find("Cached") + 7;
            strMem = strMem.substr(pos);
            TrimStr(strMem);
            pos = strMem.find(" ");
            strMem = strMem.substr(0,pos);
            cachedFree = atol(strMem.c_str());
            
        }
    }
    fclose(fd);
    return memFree+cachedFree;
}
//获取验证结果信息及删除无法验证的记录
void FileOp::getRes(int res[3])
{
    FILE *fd;
    UINT32 a=0,b=0,c=0;
    char buff[256];
    vector<string> path;
    string resPath = homePath + "/Desktop/proofRes.txt";
    if(StrategyParam::orForCompition)
        resPath = FileOp::workSpace + "/proofRes.txt";
    if(access(resPath.c_str(), F_OK) == 0) {
        ;
    }
    else
        return;
    fd = fopen(resPath.c_str(),"r");//"/home/sjg/Desktop/proofRes.txt"
    while((fgets(buff,sizeof(buff),fd)) != NULL)
    {
        string strMem(buff);
        if(strMem.find("不可满足") != string::npos)
        {
            path.push_back(homePath + "/Desktop/output/" + strMem.substr(0,strMem.find_first_of(":")));
            a++;
        }
        else if(strMem.find("可满足") != string::npos)
        {
            b++;
        }
        else if(strMem.find("无法判定") != string::npos)
        {
            c++;
        }
    }
    res[0]=a;
    res[1]=b;
    res[2]=c;
    fclose(fd);
}
//20170227 清空文件内容
void FileOp::clearRes()
{
    FILE *fd;
    string resPath = homePath + "/Desktop/proofRes.txt";
    if(StrategyParam::orForCompition)
        resPath = FileOp::workSpace + "/proofRes.txt";
    if(access(resPath.c_str(), F_OK) == 0) {
        fd = fopen(resPath.c_str(), "w+");
        fclose(fd);
    }
}
//20170220  读取策略文件，解析并给策略类成员赋值
void FileOp::readStrategy()
{
    FILE *fd;
     string resPath = homePath + "/Desktop/strategy.txt";
     if(StrategyParam::orForCompition)
        resPath = FileOp::appPath + "/strategy.txt";
    fd = fopen(resPath.c_str(),"r"); 
    if(fd == NULL)
        return;
    char buff[256];
    while((fgets(buff,sizeof(buff),fd)) != NULL)
    {
        string str(buff);
        //单元子句选取策略
        if (str.find("单元子句选取策略0") != string::npos){
            StrategyParam::unitChoose = 0;
            //cout<<"单元子句选取策略0"<<endl;
            continue;
        }
        else if (str.find("单元子句选取策略1") != string::npos){
            StrategyParam::unitChoose = 1;
            //cout<<"单元子句选取策略1"<<endl;
            continue;
        }
        else if (str.find("单元子句选取策略2") != string::npos){
            StrategyParam::unitChoose = 2;
            //cout<<"单元子句选取策略2"<<endl;
            continue;
        }
        else if (str.find("单元子句选取策略3") != string::npos){
            StrategyParam::unitChoose = 3;
            //cout<<"单元子句选取策略3"<<endl;
            continue;
        }
        else if (str.find("单元子句选取策略4") != string::npos){
            StrategyParam::unitChoose = 4;
            //cout<<"单元子句选取策略4"<<endl;
            continue;
        }
        //单元子句归结次数策略
        if (str.find("单元子句归结次数策略0") != string::npos){
            StrategyParam::unitDeduct = 0;
            //cout<<"单元子句归结次数策略0"<<endl;
            continue;
        }
        else if (str.find("单元子句归结次数策略1") != string::npos){
            StrategyParam::unitDeduct = 1;
            //cout<<"单元子句归结次数策略1"<<endl;
            continue;
        }
        else if (str.find("单元子句归结次数策略2") != string::npos){
            //cout<<"单元子句归结次数策略2"<<endl;
            StrategyParam::unitDeduct = 2;
            continue;
        }
        //单元子句冗余次数策略
        if (str.find("单元子句冗余次数策略0") != string::npos){
            //cout<<"单元子句冗余次数策略0"<<endl;
            StrategyParam::unitRedunt = 0;
            continue;
        }
        else if (str.find("单元子句冗余次数策略1") != string::npos){
            //cout<<"单元子句冗余次数策略1"<<endl;
            StrategyParam::unitRedunt = 1;
            continue;
        }
        else if (str.find("单元子句冗余次数策略2") != string::npos){
            //cout<<"单元子句冗余次数策略2"<<endl;
            StrategyParam::unitRedunt = 2;
            continue;
        }
        //单元子句稳定度策略
        if (str.find("单元子句稳定度策略0") != string::npos){
            //cout<<"单元子句稳定度策略0"<<endl;
            StrategyParam::unitSteady = 0;
            continue;
        }
        else if (str.find("单元子句稳定度策略1") != string::npos){
            //cout<<"单元子句稳定度策略1"<<endl;
            StrategyParam::unitSteady = 1;
            continue;
        }
        else if (str.find("单元子句稳定度策略2") != string::npos){
            //cout<<"单元子句稳定度策略2"<<endl;
            StrategyParam::unitSteady = 2;
            continue;
        }
        //单元子句函数嵌套层策略
        if (str.find("单元子句函数嵌套层策略0") != string::npos){
            //cout<<"单元子句函数嵌套层策略0"<<endl;
            StrategyParam::unitFuncLayer = 0;
            continue;
        }
        else if (str.find("单元子句函数嵌套层策略1") != string::npos){
            //cout<<"单元子句函数嵌套层策略1"<<endl;
            StrategyParam::unitFuncLayer = 1;
            continue;
        }
        else if (str.find("单元子句函数嵌套层策略2") != string::npos){
            //cout<<"单元子句函数嵌套层策略2"<<endl;
            StrategyParam::unitFuncLayer = 2;
            continue;
        }
        //候选子句选取策略
        if (str.find("候选子句选取策略0") != string::npos){
            //cout<<"候选子句选取策略0"<<endl;
            StrategyParam::candChoose = 0;
            continue;
        }
        else if (str.find("候选子句选取策略1") != string::npos){
            //cout<<"候选子句选取策略1"<<endl;
            StrategyParam::candChoose = 1;
            continue;
        }
        else if (str.find("候选子句选取策略2") != string::npos){
            //cout<<"候选子句选取策略2"<<endl;
            StrategyParam::candChoose = 2;
            continue;
        }
        else if (str.find("候选子句选取策略3") != string::npos){
            //cout<<"候选子句选取策略3"<<endl;
            StrategyParam::candChoose = 3;
            continue;
        }
        else if (str.find("候选子句选取策略4") != string::npos){
            //cout<<"候选子句选取策略4"<<endl;
            StrategyParam::candChoose = 4;
            continue;
        }
        //候选子句归结次数策略
        if (str.find("候选子句归结次数策略0") != string::npos){
            //cout<<"候选子句归结次数策略0"<<endl;
            StrategyParam::candDeduct = 0;
            continue;
        }
        else if (str.find("候选子句归结次数策略1") != string::npos){
            //cout<<"候选子句归结次数策略1"<<endl;
            StrategyParam::candDeduct = 1;
            continue;
        }
        else if (str.find("候选子句归结次数策略2") != string::npos){
            //cout<<"候选子句归结次数策略2"<<endl;
            StrategyParam::candDeduct = 2;
            continue;
        }
        //候选子句冗余次数策略
         if (str.find("候选子句冗余次数策略0") != string::npos){
             //cout<<"候选子句冗余次数策略0"<<endl;
            StrategyParam::candRedunt = 0;
            continue;
        }
        else if (str.find("候选子句冗余次数策略1") != string::npos){
            //cout<<"候选子句冗余次数策略1"<<endl;
            StrategyParam::candRedunt = 1;
            continue;
        }
        else if (str.find("候选子句冗余次数策略2") != string::npos){
            //cout<<"候选子句冗余次数策略2"<<endl;
            StrategyParam::candRedunt = 2;
            continue;
        }
        //候选子句文字数策略
         if (str.find("候选子句文字数策略0") != string::npos){
             //cout<<"候选子句文字数策略0"<<endl;
            StrategyParam::candClause = 0;
            continue;
        }
        else if (str.find("候选子句文字数策略1") != string::npos){
            //cout<<"候选子句文字数策略1"<<endl;
            StrategyParam::candClause = 1;
            continue;
        }
        else if (str.find("候选子句文字数策略2") != string::npos){
            //cout<<"候选子句文字数策略2"<<endl;
            StrategyParam::candClause = 2;
            continue;
        }
        //候选子句稳定度策略
       if (str.find("候选子句稳定度策略0") != string::npos){
           //cout<<"候选子句稳定度策略0"<<endl;
            StrategyParam::candSteady = 0;
            continue;
        }
        else if (str.find("候选子句稳定度策略1") != string::npos){
            //cout<<"候选子句稳定度策略1"<<endl;
            StrategyParam::candSteady = 1;
            continue;
        }
        else if (str.find("候选子句稳定度策略2") != string::npos){
            //cout<<"候选子句稳定度策略2"<<endl;
            StrategyParam::candSteady = 2;
            continue;
        }
        //单元子句归结次数最大值策略
         if (str.find("单元子句归结次数最大值策略") != string::npos){
            
            StrategyParam::unitDeductTimes = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"单元子句归结次数最大值策略"<<StrategyParam::unitDeductTimes<<endl;
            continue;
        }
        //单元子句归结次数更新策略
        if (str.find("单元子句归结次数更新策略0") != string::npos){
            //cout<<"单元子句归结次数更新策略0"<<endl;
            StrategyParam::unitDeductTimesUpdate = 0;
            continue;
        }
        else if (str.find("单元子句归结次数更新策略1") != string::npos){
            //cout<<"单元子句归结次数更新策略1"<<endl;
            StrategyParam::unitDeductTimesUpdate = 1;
            continue;
        }
        else if (str.find("单元子句归结次数更新策略2") != string::npos){
            //cout<<"单元子句归结次数更新策略2"<<endl;
            StrategyParam::unitDeductTimesUpdate = 2;
            continue;
        }
        else if (str.find("单元子句归结次数更新策略3") != string::npos){
            //cout<<"单元子句归结次数更新策略3"<<endl;
            StrategyParam::unitDeductTimesUpdate = 3;
            continue;
        }
        else if (str.find("单元子句归结次数更新策略4") != string::npos){
            //cout<<"单元子句归结次数更新策略4"<<endl;
            StrategyParam::unitDeductTimesUpdate = 4;
            continue;
        }
        //单元子句冗余次数最大值策略
        if (str.find("单元子句冗余次数最大值策略") != string::npos){
            StrategyParam::unitReduntTimes = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"单元子句冗余次数最大值策略"<<StrategyParam::unitReduntTimes<<endl;
            continue;
        }
        //单元子句冗余次数更新策略
         if (str.find("单元子句冗余次数更新策略0") != string::npos){
             //cout<<"单元子句冗余次数更新策略0"<<endl;
            StrategyParam::unitReduntTimesUpdate = 0;
            continue;
        }
        else if (str.find("单元子句冗余次数更新策略1") != string::npos){
            //cout<<"单元子句冗余次数更新策略1"<<endl;
            StrategyParam::unitReduntTimesUpdate = 1;
            continue;
        }
        else if (str.find("单元子句冗余次数更新策略2") != string::npos){
            //cout<<"单元子句冗余次数更新策略2"<<endl;
            StrategyParam::unitReduntTimesUpdate = 2;
            continue;
        }
        else if (str.find("单元子句冗余次数更新策略3") != string::npos){
            //cout<<"单元子句冗余次数更新策略3"<<endl;
            StrategyParam::unitReduntTimesUpdate = 3;
            continue;
        }
        else if (str.find("单元子句冗余次数更新策略4") != string::npos){
            //cout<<"单元子句冗余次数更新策略4"<<endl;
            StrategyParam::unitReduntTimesUpdate = 4;
            continue;
        }
        //候选子句归结次数最大值策略
        if (str.find("候选子句归结次数最大值策略") != string::npos){
            StrategyParam::candDeductTimes = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"候选子句归结次数最大值策略"<<StrategyParam::candDeductTimes<<endl;
            continue;
        }
        //候选子句归结次数更新策略
        if (str.find("候选子句归结次数更新策略0") != string::npos){
            //cout<<"候选子句归结次数更新策略0"<<endl;
            StrategyParam::candDeductTimesUpdate = 0;
            continue;
        }
        else if (str.find("候选子句归结次数更新策略1") != string::npos){
            //cout<<"候选子句归结次数更新策略1"<<endl;
            StrategyParam::candDeductTimesUpdate = 1;
            continue;
        }
        else if (str.find("候选子句归结次数更新策略2") != string::npos){
            //cout<<"候选子句归结次数更新策略2"<<endl;
            StrategyParam::candDeductTimesUpdate = 2;
            continue;
        }
        else if (str.find("候选子句归结次数更新策略3") != string::npos){
            //cout<<"候选子句归结次数更新策略3"<<endl;
            StrategyParam::candDeductTimesUpdate = 3;
            continue;
        }
        else if (str.find("候选子句归结次数更新策略4") != string::npos){
            //cout<<"候选子句归结次数更新策略4"<<endl;
            StrategyParam::candDeductTimesUpdate = 4;
            continue;
        }
        //候选子句冗余次数最大值策略
       if (str.find("候选子句冗余次数最大值策略") != string::npos){
            StrategyParam::candReduntTimes = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"候选子句冗余次数最大值策略"<<StrategyParam::candReduntTimes<<endl;
            continue;
        }
        //候选子句冗余次数更新策略
         if (str.find("候选子句冗余次数更新策略0") != string::npos){
             //cout<<"候选子句冗余次数更新策略0"<<endl;
            StrategyParam::candReduntTimesUpdate = 0;
            continue;
        }
        else if (str.find("候选子句冗余次数更新策略1") != string::npos){
            //cout<<"候选子句冗余次数更新策略1"<<endl;
            StrategyParam::candReduntTimesUpdate = 1;
            continue;
        }
        else if (str.find("候选子句冗余次数更新策略2") != string::npos){
            //cout<<"候选子句冗余次数更新策略2"<<endl;
            StrategyParam::candReduntTimesUpdate = 2;
            continue;
        }
        else if (str.find("候选子句冗余次数更新策略3") != string::npos){
            //cout<<"候选子句冗余次数更新策略3"<<endl;
            StrategyParam::candReduntTimesUpdate = 3;
            continue;
        }
        else if (str.find("候选子句冗余次数更新策略") != string::npos){
            //cout<<"候选子句冗余次数更新策略4"<<endl;
            StrategyParam::candReduntTimesUpdate = 4;
            continue;
        }
        //候选子句文字策略
        if (str.find("候选子句文字策略0") != string::npos){
            //cout<<"候选子句文字策略0"<<endl;
            StrategyParam::candLiteral = 0;
            continue;
        }
        else if (str.find("候选子句文字策略1") != string::npos){
            //cout<<"候选子句文字策略1"<<endl;
            StrategyParam::candLiteral = 1;
            continue;
        }
        else if (str.find("候选子句文字策略2") != string::npos){
            //cout<<"候选子句文字策略2"<<endl;
            StrategyParam::candLiteral = 2;
            continue;
        }
        //候选子句归结次数策略
        if (str.find("候选子句文字归结次数策略0") != string::npos){
            //cout<<"候选子句归结次数策略0"<<endl;
            StrategyParam::candLiteralDeductTimes = 0;
            continue;
        }
        else if (str.find("候选子句文字归结次数策略1") != string::npos){
            //cout<<"候选子句归结次数策略1"<<endl;
            StrategyParam::candLiteralDeductTimes = 1;
            continue;
        }
        else if (str.find("候选子句文字归结次数策略2") != string::npos){
            //cout<<"候选子句归结次数策略2"<<endl;
            StrategyParam::candLiteralDeductTimes = 2;
            continue;
        }
        //候选子句稳定度策略
        if (str.find("候选子句文字稳定度策略0") != string::npos){
            //cout<<"候选子句稳定度策略0"<<endl;
            StrategyParam::candLiteralSteady = 0;
            continue;
        }
        else if (str.find("候选子句文字稳定度策略1") != string::npos){
            //cout<<"候选子句稳定度策略1"<<endl;
            StrategyParam::candLiteralSteady = 1;
            continue;
        }
        else if (str.find("候选子句文字稳定度策略2") != string::npos){
            //cout<<"候选子句稳定度策略2"<<endl;
            StrategyParam::candLiteralSteady = 2;
            continue;
        }
        //R随机权重
        if ((str.find("R权重赋值策略0:") != string::npos)){
            StrategyParam::useRandrom = true;
            continue;
        }
        else if(str.find("R权重赋值策略1:") != string::npos)
        {
            StrategyParam::useRandrom = false;
            continue;
        }
        //R文字数大小策略
        if ((str.find("不允许小于原始子句文字最大数:") != string::npos)){
            StrategyParam::Rsmall = false;
            continue;
        }
        else if(str.find("允许小于原始子句文字最大数:") != string::npos)
        {
            StrategyParam::Rsmall = true;
            continue;
        }
         if ((str.find("不允许小于原始子句层数最大数:") != string::npos)){
            StrategyParam::RFsmall = false;
            continue;
        }
        else if(str.find("允许小于原始子句层数最大数:") != string::npos)
        {
            StrategyParam::RFsmall = true;
            continue;
        }
        //StrategyParam::RRes
        if ((str.find("不允许R因子归结:") != string::npos)){
            StrategyParam::RRes = false;
            continue;
        }
        else if(str.find("允许R因子归结:") != string::npos)
        {
            StrategyParam::RRes = true;
            continue;
        }
        if (str.find("R文字数大小策略") != string::npos){
            StrategyParam::R_MAX_NUM_TMP = stoi(str.substr(str.find_first_of(":") + 1));
            StrategyParam::R_MAX_NUM = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"R文字数大小策略"<<StrategyParam::R_MAX_NUM<<endl;
            //20170817
            if ((StrategyParam::R_MAX_NUM < StrategyParam::R_INIT_MAX_NUM) && !StrategyParam::Rsmall) {
                StrategyParam::R_MAX_NUM = StrategyParam::R_INIT_MAX_NUM;
                StrategyParam::R_MAX_NUM_TMP = StrategyParam::R_INIT_MAX_NUM;
            }
            continue;
        }
        //最大函数嵌套层限制
        if (str.find("R函数嵌套层") != string::npos){
            StrategyParam::R_MAX_FUNCLAYER = stoi(str.substr(str.find_first_of(":") + 1));
            StrategyParam::R_MAX_FUNCLAYER_TMP = stoi(str.substr(str.find_first_of(":") + 1));
//            if((StrategyParam::R_MAX_FUNCLAYER > StrategyParam::R_INIT_MAX_FUNCLAYER * 2)){
//                StrategyParam::R_MAX_FUNCLAYER = StrategyParam::R_INIT_MAX_FUNCLAYER * 2 + 1;
//                StrategyParam::R_MAX_FUNCLAYER_TMP = StrategyParam::R_INIT_MAX_FUNCLAYER * 2 + 1;
//            }
//            else
            if ((StrategyParam::R_MAX_FUNCLAYER < StrategyParam::R_INIT_MAX_FUNCLAYER) && !StrategyParam::RFsmall) {
                StrategyParam::R_MAX_FUNCLAYER = StrategyParam::R_INIT_MAX_FUNCLAYER* 2+1;
                StrategyParam::R_MAX_FUNCLAYER_TMP = StrategyParam::R_INIT_MAX_FUNCLAYER* 2+1;
            }
            continue;
        }
        //R权重大小
        if (str.find("R权重大小") != string::npos){
            StrategyParam::R_Weight = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"R权重大小"<<StrategyParam::R_Weight<<endl;
            continue;
        }
        if (str.find("R2文字数大小策略") != string::npos){
            StrategyParam::R_MAX_NUM_NOPAIR = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        }
        //中间归结式生成
//        if (str.find("中间归结式生成") != string::npos){
//            //cout<<"中间归结式生成"<<endl;
//            StrategyParam::midR = true;
//            continue;
//        }
//        else if(str.find("中间归结式不生成") != string::npos)
//        {
//            //cout<<"中间归结式不生成"<<endl;
//            StrategyParam::midR = false;
//            continue;
//        }
        if (str.find("R文字冗余策略0") != string::npos){
            //cout<<"中间归结式生成"<<endl;
            StrategyParam::litRundent = 1;
            continue;
        }
        else if(str.find("R文字冗余策略1") != string::npos)
        {
            //cout<<"中间归结式不生成"<<endl;
            StrategyParam::litRundent = 0;
            continue;
        }
        
        if (str.find("中间归结式生成策略0") != string::npos){
            //cout<<"中间归结式生成"<<endl;
            StrategyParam::midR = 0;
            continue;
        }
        else if(str.find("中间归结式生成策略1") != string::npos)
        {
            //cout<<"中间归结式不生成"<<endl;
            StrategyParam::midR = 1;
            continue;
        }
        else if(str.find("中间归结式生成策略2") != string::npos)
        {
            //cout<<"中间归结式不生成"<<endl;
            StrategyParam::midR = 2;
            continue;
        }
        else if(str.find("中间归结式生成策略3") != string::npos)
        {
            //cout<<"中间归结式不生成"<<endl;
            StrategyParam::midR = 3;
            continue;
        }
        else if(str.find("中间归结式生成策略4") != string::npos)
        {
            //cout<<"中间归结式不生成"<<endl;
            StrategyParam::midR = 4;
            continue;
        }
        else if(str.find("中间归结式生成策略5") != string::npos)
        {
            //cout<<"中间归结式不生成"<<endl;
            StrategyParam::midR = 5;
            continue;
        }
        else if(str.find("中间归结式生成策略6") != string::npos)
        {
            //cout<<"中间归结式不生成"<<endl;
            StrategyParam::midR = 6;
            continue;
        }
        else if(str.find("中间归结式生成策略7") != string::npos)
        {
            //cout<<"中间归结式不生成"<<endl;
            StrategyParam::midR = 1000;
            continue;
        }
        //项重写策略
         if (str.find("项重写策略0") != string::npos){
             //cout<<"宽深策略0"<<endl;
            StrategyParam::termRewriting = 0;
            continue;
        }
        else if (str.find("项重写策略1") != string::npos){
            //cout<<"宽深策略1"<<endl;
            StrategyParam::termRewriting = 1;
            continue;
        }
        else if (str.find("项重写策略2") != string::npos){
            //cout<<"宽深策略2"<<endl;
            StrategyParam::termRewriting = 2;
            continue;
        }
        //项重写大小策略
         if (str.find("替换项的大小策略0") != string::npos){
             //cout<<"宽深策略0"<<endl;
            StrategyParam::termRewritingSize  = 1;
            continue;
        }
        else if (str.find("替换项的大小策略1") != string::npos){
            //cout<<"宽深策略1"<<endl;
            StrategyParam::termRewritingSize  = 2;
            continue;
        }
        else if (str.find("替换项的大小策略2") != string::npos){
            //cout<<"宽深策略2"<<endl;
            StrategyParam::termRewritingSize  = 3;
            continue;
        }
        //宽深策略
         if (str.find("宽深策略0") != string::npos){
             //cout<<"宽深策略0"<<endl;
            StrategyParam::widthDeep = 0;
            continue;
        }
        else if (str.find("宽深策略1") != string::npos){
            //cout<<"宽深策略1"<<endl;
            StrategyParam::widthDeep = 1;
            continue;
        }
        else if (str.find("宽深策略2") != string::npos){
            //cout<<"宽深策略2"<<endl;
            StrategyParam::widthDeep = 2;
            continue;
        }
        //演绎深度策略
       if (str.find("演绎深度策略") != string::npos){
            StrategyParam::deductDeep = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"演绎深度策略"<<StrategyParam::deductDeep<<endl;
            continue;
        } 
        //演绎宽度策略 StrategyParam::deducWidth
        if (str.find("演绎宽度策略") != string::npos){
            StrategyParam::deducWidth = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"演绎深度策略"<<StrategyParam::deductDeep<<endl;
            continue;
        } 
        
         if (str.find("CSE版本0") != string::npos){
            //cout<<"中间归结式冗余判断"<<endl;
            StrategyParam::deductMode = 0;
            continue;
        }
        else if(str.find("CSE版本1") != string::npos)
        {
            //cout<<"中间归结式冗余不判断"<<endl;
            StrategyParam::deductMode = 1;
            StrategyParam::cseRunMode = 0;
            continue;
        }
        else if(str.find("CSE版本2") != string::npos)
        {
            //cout<<"中间归结式冗余不判断"<<endl;
            StrategyParam::deductMode = 1;
            StrategyParam::cseRunMode = 1;
            continue;
        }
        else if(str.find("CSE版本3") != string::npos)
        {
            //cout<<"中间归结式冗余不判断"<<endl;
            StrategyParam::deductMode = 1;
            StrategyParam::cseRunMode = 2;
            continue;
        }
        else if(str.find("CSE版本4") != string::npos)
        {
            //cout<<"中间归结式冗余不判断"<<endl;
            StrategyParam::deductMode = 1;
            StrategyParam::cseRunMode = 3;
            continue;
        }
        else if(str.find("CSE融合版本") != string::npos)
        {
            //cout<<"中间归结式冗余不判断"<<endl;
            StrategyParam::deductMode = 1;
            StrategyParam::cseRunMode = 4;
            continue;
        }
        //迭代次数
        if (str.find("迭代次数") != string::npos){
            StrategyParam::iterTimes = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"迭代次数"<<StrategyParam::iterTimes<<endl;
            continue;
        } 
        //迭代轮数
         if (str.find("迭代轮数") != string::npos){
            StrategyParam::iterRing = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"迭代轮数"<<StrategyParam::iterRing<<endl;
            continue;
        } 
        //时间限制
         if (str.find("时间限制") != string::npos){
            StrategyParam::timeLimit = stod(str.substr(str.find_first_of(":") + 1));
            //cout<<"时间限制"<<StrategyParam::timeLimit<<endl;
            //cout<<str<<endl;
            continue;
        } 
        //内存限制
        if (str.find("内存限制") != string::npos){
            StrategyParam::memLimit = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"内存限制"<<StrategyParam::memLimit<<endl;
            continue;
        } 
        //中间归结式冗余判断
        if (str.find("中间归结式冗余判断") != string::npos){
            //cout<<"中间归结式冗余判断"<<endl;
            StrategyParam::midRJudge = true;
            continue;
        }
        else if(str.find("中间归结式冗余不判断") != string::npos)
        {
            //cout<<"中间归结式冗余不判断"<<endl;
            StrategyParam::midRJudge = false;
            continue;
        }//StrategyParam::deductMode
        if (str.find("演绎顺序0") != string::npos){
            //cout<<"中间归结式冗余判断"<<endl;
            StrategyParam::deductMode = 0;
            continue;
        }
        else if(str.find("演绎顺序1") != string::npos)
        {
            //cout<<"中间归结式冗余不判断"<<endl;
            StrategyParam::deductMode = 1;
            continue;
        }
        //StrategyParam::deduceDepth
        if (str.find("演绎最大深度") != string::npos){
            StrategyParam::deduceDepth = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"内存限制"<<StrategyParam::memLimit<<endl;
            continue;
        } 
        //20171024
        if (str.find("重复子句次数") != string::npos){
            StrategyParam::claReUseTimes = stoi(str.substr(str.find_first_of(":") + 1));
            StrategyParam::claReUseTimesTmp = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"内存限制"<<StrategyParam::memLimit<<endl;
            continue;
        } 
        //StrategyParam::singleUseUintCla
        if (str.find("浸透方法0") != string::npos){
            //cout<<"中间归结式冗余判断"<<endl;
            StrategyParam::useSaturate = true;
            continue;
        }
        else if(str.find("浸透方法1") != string::npos)
        {
            //cout<<"中间归结式冗余不判断"<<endl;
            StrategyParam::useSaturate = false;
            continue;
        }
        //重复使用单元子句策略
        if (str.find("重复单元子句策略0") != string::npos){
            StrategyParam::useCpUintCla = true;
            continue;
        }
        else if(str.find("重复单元子句策略1") != string::npos)
        {
            StrategyParam::useCpUintCla = false;
            continue;
        }
        
        //结合系统策略使用
        if (str.find("使用结合系统策略0") != string::npos){
            //cout<<"中间归结式冗余判断"<<endl;
            StrategyParam::useCombinedSys  = 0;
            continue;
        }
        else if(str.find("使用结合系统策略1") != string::npos)
        {
            //cout<<"中间归结式冗余不判断"<<endl;
            StrategyParam::useCombinedSys  = 1;
            continue;
        }
        else if(str.find("使用结合系统策略2") != string::npos)
        {
            //cout<<"中间归结式冗余不判断"<<endl;
            StrategyParam::useCombinedSys  = 2;
            continue;
        }
        else if(str.find("使用结合系统策略3") != string::npos)
        {
            //cout<<"中间归结式冗余不判断"<<endl;
            StrategyParam::useCombinedSys  = 3;
            continue;
        }
        //结合系统结合方式策略
        if (str.find("结合方式策略0") != string::npos){
            StrategyParam::useCombinedSysMethod  = 0;//加等词公理
            continue;
        }
        else if(str.find("结合方式策略1") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 1;//不加等词公理
            continue;
        }
        else if(str.find("结合方式策略2") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 2;//S+公理+R等词子句
            continue;
        }
        else if(str.find("结合方式策略3") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 3;//S+R等词子句
            continue;
        }
        else if(str.find("结合方式策略4") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 4;//S+公理+R文字数<=2
            continue;
        }
        else if(str.find("结合方式策略5") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 5;//S+R文字数<=2
            continue;
        }
        else if(str.find("结合方式策略6") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 6;//S+公理+R文字数<=3
            continue;
        }
        else if(str.find("结合方式策略7") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 7;//S+R文字数<=3
            continue;
        }
        else if(str.find("结合方式策略8") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 8;//S+公理+所有R
            continue;
        }
        else if(str.find("结合方式策略9") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 9;//S+所有R
            continue;
        }
        else if(str.find("结合方式策略10") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 10;//S+所有R
            continue;
        }
        else if(str.find("结合方式策略11") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 11;//S+所有R
            continue;
        }
        else if(str.find("结合方式策略12") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 12;//S+所有R
            continue;
        }
        else if(str.find("结合方式策略13") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 13;//S+所有R
            continue;
        }
        //结合R策略
        if (str.find("结合R策略0") != string::npos){
            StrategyParam::combinedRMode  = 0;//
            continue;
        }
        else if(str.find("结合R策略1") != string::npos)
        {
            StrategyParam::combinedRMode  = 1;//
            continue;
        }
        else if(str.find("结合R策略2") != string::npos)
        {
            StrategyParam::combinedRMode  = 2;//
            continue;
        }
        else if(str.find("结合R策略3") != string::npos)
        {
            StrategyParam::combinedRMode  = 3;//
            continue;
        }
        
        //等词使用频度策略
        if (str.find("等词使用频度策略0") != string::npos){
            StrategyParam::equalityUsedFrq  = 0;//
            continue;
        }
        else if(str.find("等词使用频度策略1") != string::npos)
        {
            StrategyParam::equalityUsedFrq  = 1;//
            continue;
        }
        else if(str.find("等词使用频度策略2") != string::npos)
        {
            StrategyParam::equalityUsedFrq  = 2;//
            continue;
        }
        
        
        if(str.find("预处理结合策略0") != string::npos){
            StrategyParam::preprocess  = 1;
            continue;
        }
        else if(str.find("预处理结合策略1") != string::npos){
            StrategyParam::preprocess  = 0;
            continue;
        }
        //预处理策略
        if ((str.find("因子归结预处理") != string::npos)&&(str.find("不因子归结预处理") == string::npos)){
            StrategyParam::factorRes = true;
            continue;
        }
        else if(str.find("不因子归结预处理") != string::npos)
        {
            StrategyParam::factorRes = false;
            continue;
        }
         if ((str.find("等词归结预处理") != string::npos)&&(str.find("不等词归结预处理") == string::npos)){
            StrategyParam::eqnRes  = true;
            continue;
        }
        else if(str.find("不等词归结预处理") != string::npos)
        {
            StrategyParam::eqnRes  = false;
            continue;
        }
         if ((str.find("删除纯文字子句") != string::npos)&&(str.find("不删除纯文字子句") == string::npos)){
            StrategyParam::delPureCla  = true;
            continue;
        }
        else if(str.find("不删除纯文字子句") != string::npos)
        {
            StrategyParam::delPureCla  = false;
            continue;
        }
        if ((str.find("目标子句预处理") != string::npos)&&(str.find("不目标子句预处理") == string::npos)){
            StrategyParam::goalCla  = true;
            continue;
        }
        else if(str.find("不目标子句预处理") != string::npos)
        {
            StrategyParam::goalCla  = false;
            continue;
        }
        //后面增加的策略
         if (str.find("单元子句排序规则0") != string::npos){
            StrategyParam::unitSortRule = 0;
            continue;
        }
        else if (str.find("单元子句排序规则1") != string::npos){
            StrategyParam::unitSortRule = 1;
            continue;
        }
        else if (str.find("单元子句排序规则2") != string::npos){
            StrategyParam::unitSortRule = 2;
            continue;
        }
        else if (str.find("单元子句排序规则3") != string::npos){
            StrategyParam::unitSortRule = 3;
            continue;
        }
        else if (str.find("单元子句排序规则4") != string::npos){
            StrategyParam::unitSortRule = 4;
            continue;
        }
        else if (str.find("单元子句排序规则5") != string::npos){
            StrategyParam::unitSortRule = 5;
            continue;
        }
        else if (str.find("单元子句排序规则6") != string::npos){
            StrategyParam::unitSortRule = 6;
            continue;
        }
        else if (str.find("单元子句排序规则7") != string::npos){
            StrategyParam::unitSortRule = 7;
            continue;
        }
        else if (str.find("单元子句排序规则8") != string::npos){
            StrategyParam::unitSortRule = 8;
            continue;
        }
        if (str.find("子句综合函数复杂度-1") != string::npos){
             StrategyParam::claFuncComp = -1;
             StrategyParam::funcFixDeepth = 36;
            continue;
        }
        else if (str.find("子句综合函数复杂度0") != string::npos){
             StrategyParam::claFuncComp = 0;
             StrategyParam::funcFixDeepth = StrategyParam::funcOrgFixDeepthMax + 1;//StrategyParam::funcOrgFixDeepthLessMax
             
            continue;
        }
        else if (str.find("子句综合函数复杂度1") != string::npos){
            StrategyParam::claFuncComp = 1;
            StrategyParam::funcFixDeepth = StrategyParam::funcOrgFixDeepthMax + StrategyParam::funcOrgFixDeepthLessMax;
            continue;
        }
        else if (str.find("子句综合函数复杂度2") != string::npos){
            StrategyParam::claFuncComp = 2;
            StrategyParam::funcFixDeepth = StrategyParam::funcOrgFixDeepthMax*2;
            continue;
        }
        else if (str.find("子句综合函数复杂度3") != string::npos){
            StrategyParam::claFuncComp = 3;
            StrategyParam::funcFixDeepth = StrategyParam::funcOrgFixDeepthMax*3;
            continue;
        }
        else if (str.find("子句综合函数复杂度4") != string::npos){
            StrategyParam::claFuncComp = 4;
            StrategyParam::funcFixDeepth = StrategyParam::funcOrgFixDeepthMax + 10;
            continue;
        }
        //StrategyParam::unitClaUpdate
        if (str.find("单元子句更换方式0") != string::npos){
             StrategyParam::unitClaUpdate = 0;
            continue;
        }
        else if (str.find("单元子句更换方式1") != string::npos){
             StrategyParam::unitClaUpdate = 1;
            continue;
        }else if (str.find("单元子句更换方式2") != string::npos){
             StrategyParam::unitClaUpdate = 2;
            continue;
        }
       if (str.find("非单元子句之间归结") != string::npos){
            StrategyParam::noUnitRes = true;
            continue;
        }
        else if(str.find("非单元子句之间不归结") != string::npos)
        {
            StrategyParam::noUnitRes = false;
            continue;
        }
        if (str.find("非单元子句约简与结论判断") != string::npos){
            StrategyParam::noUnitSimplify = true;
            continue;
        }
        else if(str.find("非单元子句约简与结论不判断") != string::npos)
        {
            StrategyParam::noUnitSimplify = false;
            continue;
        }//divideTri
        if ((str.find("拆分三角形输出") != string::npos)&&(str.find("不拆分三角形输出") == string::npos)){
            StrategyParam::divideTri = true;
            continue;
        }
        else if(str.find("不拆分三角形输出") != string::npos)
        {
            StrategyParam::divideTri = false;
            continue;
        }//divideTri
//         if ((str.find("不允许R小于原始子句最大数:") != string::npos)){
//            StrategyParam::Rsmall = false;
//            continue;
//        }
//        else if(str.find("允许R小于原始子句最大数:") != string::npos)
//        {
//            StrategyParam::Rsmall = true;
//            continue;
//        }
        
        if ((str.find("删除无法判定记录:") != string::npos)&&(str.find("不删除无法判定记录:") == string::npos)){
            StrategyParam::delRecord = true;
            continue;
        }
        else if(str.find("不删除无法判定记录:") != string::npos)
        {
            StrategyParam::delRecord = false;
            continue;
        }//
        if ((str.find("优先生成文字少的子句:") != string::npos)&&(str.find("不优先生成文字少的子句:") == string::npos)){
            StrategyParam::genLitClause = true;
            continue;
        }
        else if(str.find("不优先生成文字少的子句:") != string::npos)
        {
            StrategyParam::genLitClause = false;
            continue;
        }//StrategyParam::strategyMode
        if (str.find("多组合策略模式0") != string::npos){
             StrategyParam::strategyMode = 0;
            continue;
        }
        else if (str.find("多组合策略模式1") != string::npos){
             StrategyParam::strategyMode = 1;
            continue;
        }
        else if (str.find("多组合策略模式2") != string::npos) {
            StrategyParam::strategyMode = 0;
            continue;
        }
        //StrategyParam::noUintCla
        if (str.find("非单元子句限制策略0") != string::npos){
             StrategyParam::noUintCla = 0;
            continue;
        }
        else if (str.find("非单元子句限制策略1") != string::npos){
             StrategyParam::noUintCla = 1;
            continue;
        }
        else if (str.find("非单元子句限制策略2") != string::npos){
             StrategyParam::noUintCla = 2;
            continue;
        }
        else if (str.find("非单元子句限制策略3") != string::npos){
             StrategyParam::noUintCla = 3;
            continue;
        }
        else if (str.find("非单元子句限制策略4") != string::npos){
             StrategyParam::noUintCla = 4;
            continue;
        }
        else if (str.find("非单元子句限制策略5") != string::npos){
             StrategyParam::noUintCla = 5;
            continue;
        }
        else if (str.find("非单元子句限制策略6") != string::npos){
             StrategyParam::noUintCla = 6;
            continue;
        }
        else if (str.find("非单元子句限制策略7") != string::npos){
             StrategyParam::noUintCla = 7;
            continue;
        }
        else if (str.find("非单元子句限制策略8") != string::npos){
             StrategyParam::noUintCla = 8;
            continue;
        }
        
        if (str.find("目标深度模式0") != string::npos){
             StrategyParam::goalDeepth = 2;
            continue;
        }
        else if (str.find("目标深度模式1") != string::npos){
             StrategyParam::goalDeepth = 3;
            continue;
        }
        else if (str.find("目标深度模式2") != string::npos){
             StrategyParam::goalDeepth = 4;
            continue;
        }
        else if (str.find("目标深度模式3") != string::npos){
             StrategyParam::goalDeepth = 5;
            continue;
        }
        else if (str.find("目标深度模式4") != string::npos){
             StrategyParam::goalDeepth = 6;
            continue;
        }
        else if (str.find("目标深度模式5") != string::npos){
             StrategyParam::goalDeepth = 7;
            continue;
        }
        else if (str.find("目标深度模式6") != string::npos){
             StrategyParam::goalDeepth = 8;
            continue;
        }
        else if (str.find("目标深度模式7") != string::npos){
             StrategyParam::goalDeepth = 9;
            continue;
        }
        else if (str.find("目标深度模式8") != string::npos){
             StrategyParam::goalDeepth = 10;
            continue;
        }
        else if (str.find("目标深度模式9") != string::npos){
             StrategyParam::goalDeepth = 200;
            continue;
        }
        //锁子句约简
        if (str.find("锁子句约简模式0") != string::npos){
             StrategyParam::lockType = 1;
            continue;
        }
        else if (str.find("锁子句约简模式1") != string::npos){
             StrategyParam::lockType = 2;
            continue;
        }
        else if (str.find("锁子句约简模式2") != string::npos){
             StrategyParam::lockType = 3;
            continue;
        }
        else if (str.find("锁子句约简模式3") != string::npos){
             StrategyParam::lockType = 4;
            continue;
        }
        else if (str.find("锁子句约简模式4") != string::npos){
             StrategyParam::lockType = 5;
            continue;
        }
        else if (str.find("锁子句约简模式5") != string::npos){
             StrategyParam::lockType = 0;
            continue;
        }
        //项代换检查冗余StrategyParam::termReRedund
        if (str.find("冗余判断策略0") != string::npos){
             StrategyParam::termReRedund = true;
            continue;
        }
        else if (str.find("冗余判断策略1") != string::npos){
             StrategyParam::termReRedund = false;
            continue;
        }
    }
    fclose(fd);
}

//20170708 自动模式更换策略
void FileOp::readStrategyN(int n)
{
    string strFile;
    strFile = FileOp::findStrategy(FileOp::strategyFile, n);
    FileOp::readBatchStrategy(strFile);//读取策略 FileOp::readBatchStrategy(FileOp::StrategyfileName[len]);
}

void FileOp::readStrategyNTptp(int n)
{
    string strFile;
    strFile = FileOp::findStrategyTptp(FileOp::strategyFile, n);
    
    cout<< "the " + to_string(n+1) + "th used strategy: "<< strFile << endl;
    FileOp::readBatchStrategy(strFile);//读取策略 FileOp::readBatchStrategy(FileOp::StrategyfileName[len]);
}

string FileOp::getStrategyNTptp(int n)
{
    string strFile;
    strFile = FileOp::findStrategyTptp(FileOp::strategyFile, n);
    return strFile;
}

//20170708  批量读取策略文件，解析并给策略类成员赋值
void FileOp::readBatchStrategy(string path)
{
    FILE *fd;
    //string resPath = homePath + "/Desktop/strategy.txt";
    fd = fopen(path.c_str(),"r"); 
    if(fd == NULL)
        return;
    char buff[256];
    while((fgets(buff,sizeof(buff),fd)) != NULL)
    {
        string str(buff);
        //单元子句选取策略
        if (str.find("单元子句选取策略0") != string::npos){
            StrategyParam::unitChoose = 0;
            //cout<<"单元子句选取策略0"<<endl;
            continue;
        }
        else if (str.find("单元子句选取策略1") != string::npos){
            StrategyParam::unitChoose = 1;
            //cout<<"单元子句选取策略1"<<endl;
            continue;
        }
        else if (str.find("单元子句选取策略2") != string::npos){
            StrategyParam::unitChoose = 2;
            //cout<<"单元子句选取策略2"<<endl;
            continue;
        }
        else if (str.find("单元子句选取策略3") != string::npos){
            StrategyParam::unitChoose = 3;
            //cout<<"单元子句选取策略3"<<endl;
            continue;
        }
        else if (str.find("单元子句选取策略4") != string::npos){
            StrategyParam::unitChoose = 4;
            //cout<<"单元子句选取策略4"<<endl;
            continue;
        }
        //单元子句归结次数策略
        if (str.find("单元子句归结次数策略0") != string::npos){
            StrategyParam::unitDeduct = 0;
            //cout<<"单元子句归结次数策略0"<<endl;
            continue;
        }
        else if (str.find("单元子句归结次数策略1") != string::npos){
            StrategyParam::unitDeduct = 1;
            //cout<<"单元子句归结次数策略1"<<endl;
            continue;
        }
        else if (str.find("单元子句归结次数策略2") != string::npos){
            //cout<<"单元子句归结次数策略2"<<endl;
            StrategyParam::unitDeduct = 2;
            continue;
        }
        //单元子句冗余次数策略
        if (str.find("单元子句冗余次数策略0") != string::npos){
            //cout<<"单元子句冗余次数策略0"<<endl;
            StrategyParam::unitRedunt = 0;
            continue;
        }
        else if (str.find("单元子句冗余次数策略1") != string::npos){
            //cout<<"单元子句冗余次数策略1"<<endl;
            StrategyParam::unitRedunt = 1;
            continue;
        }
        else if (str.find("单元子句冗余次数策略2") != string::npos){
            //cout<<"单元子句冗余次数策略2"<<endl;
            StrategyParam::unitRedunt = 2;
            continue;
        }
        //单元子句稳定度策略
        if (str.find("单元子句稳定度策略0") != string::npos){
            //cout<<"单元子句稳定度策略0"<<endl;
            StrategyParam::unitSteady = 0;
            continue;
        }
        else if (str.find("单元子句稳定度策略1") != string::npos){
            //cout<<"单元子句稳定度策略1"<<endl;
            StrategyParam::unitSteady = 1;
            continue;
        }
        else if (str.find("单元子句稳定度策略2") != string::npos){
            //cout<<"单元子句稳定度策略2"<<endl;
            StrategyParam::unitSteady = 2;
            continue;
        }
        //单元子句函数嵌套层策略
        if (str.find("单元子句函数嵌套层策略0") != string::npos){
            //cout<<"单元子句函数嵌套层策略0"<<endl;
            StrategyParam::unitFuncLayer = 0;
            continue;
        }
        else if (str.find("单元子句函数嵌套层策略1") != string::npos){
            //cout<<"单元子句函数嵌套层策略1"<<endl;
            StrategyParam::unitFuncLayer = 1;
            continue;
        }
        else if (str.find("单元子句函数嵌套层策略2") != string::npos){
            //cout<<"单元子句函数嵌套层策略2"<<endl;
            StrategyParam::unitFuncLayer = 2;
            continue;
        }
        //候选子句选取策略
        if (str.find("候选子句选取策略0") != string::npos){
            //cout<<"候选子句选取策略0"<<endl;
            StrategyParam::candChoose = 0;
            continue;
        }
        else if (str.find("候选子句选取策略1") != string::npos){
            //cout<<"候选子句选取策略1"<<endl;
            StrategyParam::candChoose = 1;
            continue;
        }
        else if (str.find("候选子句选取策略2") != string::npos){
            //cout<<"候选子句选取策略2"<<endl;
            StrategyParam::candChoose = 2;
            continue;
        }
        else if (str.find("候选子句选取策略3") != string::npos){
            //cout<<"候选子句选取策略3"<<endl;
            StrategyParam::candChoose = 3;
            continue;
        }
        else if (str.find("候选子句选取策略4") != string::npos){
            //cout<<"候选子句选取策略4"<<endl;
            StrategyParam::candChoose = 4;
            continue;
        }
        //候选子句归结次数策略
        if (str.find("候选子句归结次数策略0") != string::npos){
            //cout<<"候选子句归结次数策略0"<<endl;
            StrategyParam::candDeduct = 0;
            continue;
        }
        else if (str.find("候选子句归结次数策略1") != string::npos){
            //cout<<"候选子句归结次数策略1"<<endl;
            StrategyParam::candDeduct = 1;
            continue;
        }
        else if (str.find("候选子句归结次数策略2") != string::npos){
            //cout<<"候选子句归结次数策略2"<<endl;
            StrategyParam::candDeduct = 2;
            continue;
        }
        //候选子句冗余次数策略
         if (str.find("候选子句冗余次数策略0") != string::npos){
             //cout<<"候选子句冗余次数策略0"<<endl;
            StrategyParam::candRedunt = 0;
            continue;
        }
        else if (str.find("候选子句冗余次数策略1") != string::npos){
            //cout<<"候选子句冗余次数策略1"<<endl;
            StrategyParam::candRedunt = 1;
            continue;
        }
        else if (str.find("候选子句冗余次数策略2") != string::npos){
            //cout<<"候选子句冗余次数策略2"<<endl;
            StrategyParam::candRedunt = 2;
            continue;
        }
        //候选子句文字数策略
         if (str.find("候选子句文字数策略0") != string::npos){
             //cout<<"候选子句文字数策略0"<<endl;
            StrategyParam::candClause = 0;
            continue;
        }
        else if (str.find("候选子句文字数策略1") != string::npos){
            //cout<<"候选子句文字数策略1"<<endl;
            StrategyParam::candClause = 1;
            continue;
        }
        else if (str.find("候选子句文字数策略2") != string::npos){
            //cout<<"候选子句文字数策略2"<<endl;
            StrategyParam::candClause = 2;
            continue;
        }
        //候选子句稳定度策略
       if (str.find("候选子句稳定度策略0") != string::npos){
           //cout<<"候选子句稳定度策略0"<<endl;
            StrategyParam::candSteady = 0;
            continue;
        }
        else if (str.find("候选子句稳定度策略1") != string::npos){
            //cout<<"候选子句稳定度策略1"<<endl;
            StrategyParam::candSteady = 1;
            continue;
        }
        else if (str.find("候选子句稳定度策略2") != string::npos){
            //cout<<"候选子句稳定度策略2"<<endl;
            StrategyParam::candSteady = 2;
            continue;
        }
        //单元子句归结次数最大值策略
         if (str.find("单元子句归结次数最大值策略") != string::npos){
            
            StrategyParam::unitDeductTimes = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"单元子句归结次数最大值策略"<<StrategyParam::unitDeductTimes<<endl;
            continue;
        }
        //单元子句归结次数更新策略
        if (str.find("单元子句归结次数更新策略0") != string::npos){
            //cout<<"单元子句归结次数更新策略0"<<endl;
            StrategyParam::unitDeductTimesUpdate = 0;
            continue;
        }
        else if (str.find("单元子句归结次数更新策略1") != string::npos){
            //cout<<"单元子句归结次数更新策略1"<<endl;
            StrategyParam::unitDeductTimesUpdate = 1;
            continue;
        }
        else if (str.find("单元子句归结次数更新策略2") != string::npos){
            //cout<<"单元子句归结次数更新策略2"<<endl;
            StrategyParam::unitDeductTimesUpdate = 2;
            continue;
        }
        else if (str.find("单元子句归结次数更新策略3") != string::npos){
            //cout<<"单元子句归结次数更新策略3"<<endl;
            StrategyParam::unitDeductTimesUpdate = 3;
            continue;
        }
        else if (str.find("单元子句归结次数更新策略4") != string::npos){
            //cout<<"单元子句归结次数更新策略4"<<endl;
            StrategyParam::unitDeductTimesUpdate = 4;
            continue;
        }
        //单元子句冗余次数最大值策略
        if (str.find("单元子句冗余次数最大值策略") != string::npos){
            StrategyParam::unitReduntTimes = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"单元子句冗余次数最大值策略"<<StrategyParam::unitReduntTimes<<endl;
            continue;
        }
        //单元子句冗余次数更新策略
         if (str.find("单元子句冗余次数更新策略0") != string::npos){
             //cout<<"单元子句冗余次数更新策略0"<<endl;
            StrategyParam::unitReduntTimesUpdate = 0;
            continue;
        }
        else if (str.find("单元子句冗余次数更新策略1") != string::npos){
            //cout<<"单元子句冗余次数更新策略1"<<endl;
            StrategyParam::unitReduntTimesUpdate = 1;
            continue;
        }
        else if (str.find("单元子句冗余次数更新策略2") != string::npos){
            //cout<<"单元子句冗余次数更新策略2"<<endl;
            StrategyParam::unitReduntTimesUpdate = 2;
            continue;
        }
        else if (str.find("单元子句冗余次数更新策略3") != string::npos){
            //cout<<"单元子句冗余次数更新策略3"<<endl;
            StrategyParam::unitReduntTimesUpdate = 3;
            continue;
        }
        else if (str.find("单元子句冗余次数更新策略4") != string::npos){
            //cout<<"单元子句冗余次数更新策略4"<<endl;
            StrategyParam::unitReduntTimesUpdate = 4;
            continue;
        }
        //候选子句归结次数最大值策略
        if (str.find("候选子句归结次数最大值策略") != string::npos){
            StrategyParam::candDeductTimes = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"候选子句归结次数最大值策略"<<StrategyParam::candDeductTimes<<endl;
            continue;
        }
        //候选子句归结次数更新策略
        if (str.find("候选子句归结次数更新策略0") != string::npos){
            //cout<<"候选子句归结次数更新策略0"<<endl;
            StrategyParam::candDeductTimesUpdate = 0;
            continue;
        }
        else if (str.find("候选子句归结次数更新策略1") != string::npos){
            //cout<<"候选子句归结次数更新策略1"<<endl;
            StrategyParam::candDeductTimesUpdate = 1;
            continue;
        }
        else if (str.find("候选子句归结次数更新策略2") != string::npos){
            //cout<<"候选子句归结次数更新策略2"<<endl;
            StrategyParam::candDeductTimesUpdate = 2;
            continue;
        }
        else if (str.find("候选子句归结次数更新策略3") != string::npos){
            //cout<<"候选子句归结次数更新策略3"<<endl;
            StrategyParam::candDeductTimesUpdate = 3;
            continue;
        }
        else if (str.find("候选子句归结次数更新策略4") != string::npos){
            //cout<<"候选子句归结次数更新策略4"<<endl;
            StrategyParam::candDeductTimesUpdate = 4;
            continue;
        }
        //候选子句冗余次数最大值策略
       if (str.find("候选子句冗余次数最大值策略") != string::npos){
            StrategyParam::candReduntTimes = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"候选子句冗余次数最大值策略"<<StrategyParam::candReduntTimes<<endl;
            continue;
        }
        //候选子句冗余次数更新策略
         if (str.find("候选子句冗余次数更新策略0") != string::npos){
             //cout<<"候选子句冗余次数更新策略0"<<endl;
            StrategyParam::candReduntTimesUpdate = 0;
            continue;
        }
        else if (str.find("候选子句冗余次数更新策略1") != string::npos){
            //cout<<"候选子句冗余次数更新策略1"<<endl;
            StrategyParam::candReduntTimesUpdate = 1;
            continue;
        }
        else if (str.find("候选子句冗余次数更新策略2") != string::npos){
            //cout<<"候选子句冗余次数更新策略2"<<endl;
            StrategyParam::candReduntTimesUpdate = 2;
            continue;
        }
        else if (str.find("候选子句冗余次数更新策略3") != string::npos){
            //cout<<"候选子句冗余次数更新策略3"<<endl;
            StrategyParam::candReduntTimesUpdate = 3;
            continue;
        }
        else if (str.find("候选子句冗余次数更新策略") != string::npos){
            //cout<<"候选子句冗余次数更新策略4"<<endl;
            StrategyParam::candReduntTimesUpdate = 4;
            continue;
        }
        //候选子句文字策略
        if (str.find("候选子句文字策略0") != string::npos){
            //cout<<"候选子句文字策略0"<<endl;
            StrategyParam::candLiteral = 0;
            continue;
        }
        else if (str.find("候选子句文字策略1") != string::npos){
            //cout<<"候选子句文字策略1"<<endl;
            StrategyParam::candLiteral = 1;
            continue;
        }
        else if (str.find("候选子句文字策略2") != string::npos){
            //cout<<"候选子句文字策略2"<<endl;
            StrategyParam::candLiteral = 2;
            continue;
        }
        //候选子句归结次数策略
        if (str.find("候选子句文字归结次数策略0") != string::npos){
            //cout<<"候选子句归结次数策略0"<<endl;
            StrategyParam::candLiteralDeductTimes = 0;
            continue;
        }
        else if (str.find("候选子句文字归结次数策略1") != string::npos){
            //cout<<"候选子句归结次数策略1"<<endl;
            StrategyParam::candLiteralDeductTimes = 1;
            continue;
        }
        else if (str.find("候选子句文字归结次数策略2") != string::npos){
            //cout<<"候选子句归结次数策略2"<<endl;
            StrategyParam::candLiteralDeductTimes = 2;
            continue;
        }
        /*
         * 候选子句文字归结次数策略0:由低到高
            候选子句文字稳定度策略2:由低到高
         */
        //候选子句稳定度策略
        if (str.find("候选子句文字稳定度策略0") != string::npos){
            //cout<<"候选子句稳定度策略0"<<endl;
            StrategyParam::candLiteralSteady = 0;
            continue;
        }
        else if (str.find("候选子句文字稳定度策略1") != string::npos){
            //cout<<"候选子句稳定度策略1"<<endl;
            StrategyParam::candLiteralSteady = 1;
            continue;
        }
        else if (str.find("候选子句文字稳定度策略2") != string::npos){
            //cout<<"候选子句稳定度策略2"<<endl;
            StrategyParam::candLiteralSteady = 2;
            continue;
        }
        //R随机权重
        if ((str.find("R权重赋值策略0:") != string::npos)){
            StrategyParam::useRandrom = true;
            continue;
        }
        else if(str.find("R权重赋值策略1:") != string::npos)
        {
            StrategyParam::useRandrom = false;
            continue;
        }
        //R文字数大小策略
        if ((str.find("不允许小于原始子句文字最大数:") != string::npos)){
            StrategyParam::Rsmall = false;
            continue;
        }
        else if(str.find("允许小于原始子句文字最大数:") != string::npos)
        {
            StrategyParam::Rsmall = true;
            continue;
        }
         if ((str.find("不允许小于原始子句层数最大数:") != string::npos)){
            StrategyParam::RFsmall = false;
            continue;
        }
        else if(str.find("允许小于原始子句层数最大数:") != string::npos)
        {
            StrategyParam::RFsmall = true;
            continue;
        }
        //StrategyParam::RRes
        if ((str.find("不允许R因子归结:") != string::npos)){
            StrategyParam::RRes = false;
            continue;
        }
        else if(str.find("允许R因子归结:") != string::npos)
        {
            StrategyParam::RRes = true;
            continue;
        }
        if (str.find("R文字数大小策略") != string::npos){
            StrategyParam::R_MAX_NUM_TMP = stoi(str.substr(str.find_first_of(":") + 1));
            StrategyParam::R_MAX_NUM = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"R文字数大小策略"<<StrategyParam::R_MAX_NUM<<endl;
            //20170817
            if ((StrategyParam::R_MAX_NUM < StrategyParam::R_INIT_MAX_NUM) && !StrategyParam::Rsmall) {
                StrategyParam::R_MAX_NUM = StrategyParam::R_INIT_MAX_NUM;
                StrategyParam::R_MAX_NUM_TMP = StrategyParam::R_INIT_MAX_NUM;
            }
            continue;
        }
        //最大函数嵌套层限制
        if (str.find("R函数嵌套层") != string::npos){
            StrategyParam::R_MAX_FUNCLAYER = stoi(str.substr(str.find_first_of(":") + 1));
            StrategyParam::R_MAX_FUNCLAYER_TMP = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"R函数嵌套层"<<StrategyParam::R_MAX_FUNCLAYER<<endl;
            //20170817
//            if((StrategyParam::R_MAX_FUNCLAYER > StrategyParam::R_INIT_MAX_FUNCLAYER * 2) ){
//                StrategyParam::R_MAX_FUNCLAYER = StrategyParam::R_INIT_MAX_FUNCLAYER * 2 + 1;
//                StrategyParam::R_MAX_FUNCLAYER_TMP = StrategyParam::R_INIT_MAX_FUNCLAYER * 2 + 1;
//            }
//            else 
           if ((StrategyParam::R_MAX_FUNCLAYER < StrategyParam::R_INIT_MAX_FUNCLAYER) && !StrategyParam::RFsmall) {
                StrategyParam::R_MAX_FUNCLAYER = StrategyParam::R_INIT_MAX_FUNCLAYER * 2 + 1;
                StrategyParam::R_MAX_FUNCLAYER_TMP = StrategyParam::R_INIT_MAX_FUNCLAYER * 2 + 1;
            }
            continue;
        }
        //R权重大小
        if (str.find("R权重大小") != string::npos){
            StrategyParam::R_Weight = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"R权重大小"<<StrategyParam::R_Weight<<endl;
            continue;
        }
        if (str.find("R2文字数大小策略") != string::npos){
            StrategyParam::R_MAX_NUM_NOPAIR = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        }
        //中间归结式生成
//        if (str.find("中间归结式生成") != string::npos){
//            //cout<<"中间归结式生成"<<endl;
//            StrategyParam::midR = true;
//            continue;
//        }
//        else if(str.find("中间归结式不生成") != string::npos)
//        {
//            //cout<<"中间归结式不生成"<<endl;
//            StrategyParam::midR = false;
//            continue;
//        }
         if (str.find("R文字冗余策略0") != string::npos){
            //cout<<"中间归结式生成"<<endl;
            StrategyParam::litRundent = 1;
            continue;
        }
        else if(str.find("R文字冗余策略1") != string::npos)
        {
            //cout<<"中间归结式不生成"<<endl;
            StrategyParam::litRundent = 0;
            continue;
        }
        if (str.find("中间归结式生成策略0") != string::npos){
            //cout<<"中间归结式生成"<<endl;
            StrategyParam::midR = 0;
            continue;
        }
        else if(str.find("中间归结式生成策略1") != string::npos)
        {
            //cout<<"中间归结式不生成"<<endl;
            StrategyParam::midR = 1;
            continue;
        }
        else if(str.find("中间归结式生成策略2") != string::npos)
        {
            //cout<<"中间归结式不生成"<<endl;
            StrategyParam::midR = 2;
            continue;
        }
        else if(str.find("中间归结式生成策略3") != string::npos)
        {
            //cout<<"中间归结式不生成"<<endl;
            StrategyParam::midR = 3;
            continue;
        }
        else if(str.find("中间归结式生成策略4") != string::npos)
        {
            //cout<<"中间归结式不生成"<<endl;
            StrategyParam::midR = 4;
            continue;
        }
        else if(str.find("中间归结式生成策略5") != string::npos)
        {
            //cout<<"中间归结式不生成"<<endl;
            StrategyParam::midR = 5;
            continue;
        }
        else if(str.find("中间归结式生成策略6") != string::npos)
        {
            //cout<<"中间归结式不生成"<<endl;
            StrategyParam::midR = 6;
            continue;
        }
        else if(str.find("中间归结式生成策略7") != string::npos)
        {
            //cout<<"中间归结式不生成"<<endl;
            StrategyParam::midR = 1000;
            continue;
        }
        //宽深策略
         if (str.find("宽深策略0") != string::npos){
             //cout<<"宽深策略0"<<endl;
            StrategyParam::widthDeep = 0;
            continue;
        }
        else if (str.find("宽深策略1") != string::npos){
            //cout<<"宽深策略1"<<endl;
            StrategyParam::widthDeep = 1;
            continue;
        }
        else if (str.find("宽深策略2") != string::npos){
            //cout<<"宽深策略2"<<endl;
            StrategyParam::widthDeep = 2;
            continue;
        }
        //项重写策略
         if (str.find("项重写策略0") != string::npos){
             //cout<<"宽深策略0"<<endl;
            StrategyParam::termRewriting = 0;
            continue;
        }
        else if (str.find("项重写策略1") != string::npos){
            //cout<<"宽深策略1"<<endl;
            StrategyParam::termRewriting = 1;
            continue;
        }
        else if (str.find("项重写策略2") != string::npos){
            //cout<<"宽深策略2"<<endl;
            StrategyParam::termRewriting = 2;
            continue;
        }
         //项重写大小策略
         if (str.find("替换项的大小策略0") != string::npos){
             //cout<<"宽深策略0"<<endl;
            StrategyParam::termRewritingSize  = 1;
            continue;
        }
        else if (str.find("替换项的大小策略1") != string::npos){
            //cout<<"宽深策略1"<<endl;
            StrategyParam::termRewritingSize  = 2;
            continue;
        }
        else if (str.find("替换项的大小策略2") != string::npos){
            //cout<<"宽深策略2"<<endl;
            StrategyParam::termRewritingSize  = 3;
            continue;
        }
        //演绎深度策略
       if (str.find("演绎深度策略") != string::npos){
            StrategyParam::deductDeep = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"演绎深度策略"<<StrategyParam::deductDeep<<endl;
            continue;
        } 
        //演绎宽度策略 StrategyParam::deducWidth
        if (str.find("演绎宽度策略") != string::npos){
            StrategyParam::deducWidth = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"演绎深度策略"<<StrategyParam::deductDeep<<endl;
            continue;
        } 
        //迭代次数
        if (str.find("迭代次数") != string::npos){
            StrategyParam::iterTimes = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"迭代次数"<<StrategyParam::iterTimes<<endl;
            continue;
        } 
        //迭代轮数
         if (str.find("迭代轮数") != string::npos){
            StrategyParam::iterRing = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"迭代轮数"<<StrategyParam::iterRing<<endl;
            continue;
        } 
        //时间限制
         if (str.find("时间限制") != string::npos){
            StrategyParam::timeLimit = stod(str.substr(str.find_first_of(":") + 1));
            //cout<<"时间限制"<<StrategyParam::timeLimit<<endl;
            //cout<<str<<endl;
            continue;
        } 
        //内存限制
        if (str.find("内存限制") != string::npos){
            StrategyParam::memLimit = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"内存限制"<<StrategyParam::memLimit<<endl;
            continue;
        } 
        //中间归结式冗余判断
        if (str.find("中间归结式冗余判断") != string::npos){
            //cout<<"中间归结式冗余判断"<<endl;
            StrategyParam::midRJudge = true;
            continue;
        }
        else if(str.find("中间归结式冗余不判断") != string::npos)
        {
            //cout<<"中间归结式冗余不判断"<<endl;
            StrategyParam::midRJudge = false;
            continue;
        }
        if (str.find("演绎顺序0") != string::npos){
            //cout<<"中间归结式冗余判断"<<endl;
            StrategyParam::deductMode = 0;
            continue;
        }
        else if(str.find("演绎顺序1") != string::npos)
        {
            //cout<<"中间归结式冗余不判断"<<endl;
            StrategyParam::deductMode = 1;
            continue;
        }
        //StrategyParam::deduceDepth
        if (str.find("演绎最大深度") != string::npos){
            StrategyParam::deduceDepth = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"内存限制"<<StrategyParam::memLimit<<endl;
            continue;
        } 
        //重复使用单元子句策略
        if (str.find("重复单元子句策略0") != string::npos){
            StrategyParam::useCpUintCla = true;
            continue;
        }
        else if(str.find("重复单元子句策略1") != string::npos)
        {
            StrategyParam::useCpUintCla = false;
            continue;
        }
        //20171024
        if (str.find("重复子句次数") != string::npos){
            StrategyParam::claReUseTimes = stoi(str.substr(str.find_first_of(":") + 1));
            StrategyParam::claReUseTimesTmp = stoi(str.substr(str.find_first_of(":") + 1));
            //cout<<"内存限制"<<StrategyParam::memLimit<<endl;
            continue;
        } 
        //prover9使用
        if (str.find("使用结合系统策略0") != string::npos){
            //cout<<"中间归结式冗余判断"<<endl;
            StrategyParam::useCombinedSys  = 0;
            continue;
        }
        else if(str.find("使用结合系统策略1") != string::npos)
        {
            //cout<<"中间归结式冗余不判断"<<endl;
            StrategyParam::useCombinedSys  = 1;
            continue;
        }
        else if(str.find("使用结合系统策略2") != string::npos)
        {
            //cout<<"中间归结式冗余不判断"<<endl;
            StrategyParam::useCombinedSys  = 2;
            continue;
        }
        else if(str.find("使用结合系统策略3") != string::npos)
        {
            //cout<<"中间归结式冗余不判断"<<endl;
            StrategyParam::useCombinedSys  = 3;
            continue;
        }
         //结合系统结合方式策略
        if (str.find("结合方式策略0") != string::npos){
            StrategyParam::useCombinedSysMethod  = 0;//加等词公理
            continue;
        }
        else if(str.find("结合方式策略1") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 1;//不加等词公理
            continue;
        }
        else if(str.find("结合方式策略2") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 2;//S+公理+R等词子句
            continue;
        }
        else if(str.find("结合方式策略3") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 3;//S+R等词子句
            continue;
        }
        else if(str.find("结合方式策略4") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 4;//S+公理+R文字数<=2
            continue;
        }
        else if(str.find("结合方式策略5") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 5;//S+R文字数<=2
            continue;
        }
        else if(str.find("结合方式策略6") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 6;//S+公理+R文字数<=3
            continue;
        }
        else if(str.find("结合方式策略7") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 7;//S+R文字数<=3
            continue;
        }
        else if(str.find("结合方式策略8") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 8;//S+公理+所有R
            continue;
        }
        else if(str.find("结合方式策略9") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 9;//S+所有R
            continue;
        }
        else if(str.find("结合方式策略10") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 10;//S+所有R
            continue;
        }
        else if(str.find("结合方式策略11") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 11;//S+所有R
            continue;
        }
        else if(str.find("结合方式策略12") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 12;//S+所有R
            continue;
        }
        else if(str.find("结合方式策略13") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 13;//S+所有R
            continue;
        }
        //结合R策略
        if (str.find("结合R策略0") != string::npos){
            StrategyParam::combinedRMode  = 0;//
            continue;
        }
        else if(str.find("结合R策略1") != string::npos)
        {
            StrategyParam::combinedRMode  = 1;//
            continue;
        }
        else if(str.find("结合R策略2") != string::npos)
        {
            StrategyParam::combinedRMode  = 2;//
            continue;
        }
        else if(str.find("结合R策略3") != string::npos)
        {
            StrategyParam::combinedRMode  = 3;//
            continue;
        }
        
        //等词使用频度策略
        if (str.find("等词使用频度策略0") != string::npos){
            StrategyParam::equalityUsedFrq  = 0;//
            continue;
        }
        else if(str.find("等词使用频度策略1") != string::npos)
        {
            StrategyParam::equalityUsedFrq  = 1;//
            continue;
        }
        else if(str.find("等词使用频度策略2") != string::npos)
        {
            StrategyParam::equalityUsedFrq  = 2;//
            continue;
        }
        
        if(str.find("预处理结合策略0") != string::npos){
            StrategyParam::preprocess  = 1;
            continue;
        }
        else if(str.find("预处理结合策略1") != string::npos){
            StrategyParam::preprocess  = 0;
            continue;
        }
        
        //StrategyParam::singleUseUintCla
        if (str.find("浸透方法0") != string::npos){
            //cout<<"中间归结式冗余判断"<<endl;
            StrategyParam::useSaturate = true;
            continue;
        }
        else if(str.find("浸透方法1") != string::npos)
        {
            //cout<<"中间归结式冗余不判断"<<endl;
            StrategyParam::useSaturate = false;
            continue;
        }
        //预处理策略
        if ((str.find("因子归结预处理") != string::npos)&&(str.find("不因子归结预处理") == string::npos)){
            StrategyParam::factorRes = true;
            continue;
        }
        else if(str.find("不因子归结预处理") != string::npos)
        {
            StrategyParam::factorRes = false;
            continue;
        }
         if ((str.find("等词归结预处理") != string::npos)&&(str.find("不等词归结预处理") == string::npos)){
            StrategyParam::eqnRes  = true;
            continue;
        }
        else if(str.find("不等词归结预处理") != string::npos)
        {
            StrategyParam::eqnRes  = false;
            continue;
        }
         if ((str.find("删除纯文字子句") != string::npos)&&(str.find("不删除纯文字子句") == string::npos)){
            StrategyParam::delPureCla  = true;
            continue;
        }
        else if(str.find("不删除纯文字子句") != string::npos)
        {
            StrategyParam::delPureCla  = false;
            continue;
        }
        if ((str.find("目标子句预处理") != string::npos)&&(str.find("不目标子句预处理") == string::npos)){
            StrategyParam::goalCla  = true;
            continue;
        }
        else if(str.find("不目标子句预处理") != string::npos)
        {
            StrategyParam::goalCla  = false;
            continue;
        }
        //后面增加的策略
         if (str.find("单元子句排序规则0") != string::npos){
            StrategyParam::unitSortRule = 0;
            continue;
        }
        else if (str.find("单元子句排序规则1") != string::npos){
            StrategyParam::unitSortRule = 1;
            continue;
        }
        else if (str.find("单元子句排序规则2") != string::npos){
            StrategyParam::unitSortRule = 2;
            continue;
        }
        else if (str.find("单元子句排序规则3") != string::npos){
            StrategyParam::unitSortRule = 3;
            continue;
        }
        else if (str.find("单元子句排序规则4") != string::npos){
            StrategyParam::unitSortRule = 4;
            continue;
        }
        else if (str.find("单元子句排序规则5") != string::npos){
            StrategyParam::unitSortRule = 5;
            continue;
        }
        else if (str.find("单元子句排序规则6") != string::npos){
            StrategyParam::unitSortRule = 6;
            continue;
        }
        else if (str.find("单元子句排序规则7") != string::npos){
            StrategyParam::unitSortRule = 7;
            continue;
        }
        else if (str.find("单元子句排序规则8") != string::npos){
            StrategyParam::unitSortRule = 8;
            continue;
        }
        if (str.find("子句综合函数复杂度-1") != string::npos){
             StrategyParam::claFuncComp = -1;
             StrategyParam::funcFixDeepth = 36;
            continue;
        }
        else if (str.find("子句综合函数复杂度0") != string::npos){
             StrategyParam::claFuncComp = 0;
             StrategyParam::funcFixDeepth = StrategyParam::funcOrgFixDeepthMax + 1;
            continue;
        }
        else if (str.find("子句综合函数复杂度1") != string::npos){
            StrategyParam::claFuncComp = 1;
            StrategyParam::funcFixDeepth = StrategyParam::funcOrgFixDeepthMax + StrategyParam::funcOrgFixDeepthLessMax;
            continue;
        }
        else if (str.find("子句综合函数复杂度2") != string::npos){
            StrategyParam::claFuncComp = 2;
            StrategyParam::funcFixDeepth = StrategyParam::funcOrgFixDeepthMax*2;
            continue;
        }
        else if (str.find("子句综合函数复杂度3") != string::npos){
            StrategyParam::claFuncComp = 3;
            StrategyParam::funcFixDeepth = StrategyParam::funcOrgFixDeepthMax*3;
            continue;
        }
        else if (str.find("子句综合函数复杂度4") != string::npos){
            StrategyParam::claFuncComp = 4;
            StrategyParam::funcFixDeepth = StrategyParam::funcOrgFixDeepthMax + 10;
            continue;
        }
        //StrategyParam::unitClaUpdate
        if (str.find("单元子句更换方式0") != string::npos){
             StrategyParam::unitClaUpdate = 0;
            continue;
        }
        else if (str.find("单元子句更换方式1") != string::npos){
             StrategyParam::unitClaUpdate = 1;
            continue;
        }else if (str.find("单元子句更换方式2") != string::npos){
             StrategyParam::unitClaUpdate = 2;
            continue;
        }
       if (str.find("非单元子句之间归结") != string::npos){
            StrategyParam::noUnitRes = true;
            continue;
        }
        else if(str.find("非单元子句之间不归结") != string::npos)
        {
            StrategyParam::noUnitRes = false;
            continue;
        }
        if (str.find("非单元子句约简与结论判断") != string::npos){
            StrategyParam::noUnitSimplify = true;
            continue;
        }
        else if(str.find("非单元子句约简与结论不判断") != string::npos)
        {
            StrategyParam::noUnitSimplify = false;
            continue;
        }//divideTri
        if ((str.find("拆分三角形输出") != string::npos)&&(str.find("不拆分三角形输出") == string::npos)){
            StrategyParam::divideTri = true;
            continue;
        }
        else if(str.find("不拆分三角形输出") != string::npos)
        {
            StrategyParam::divideTri = false;
            continue;
        }//divideTri
//         if ((str.find("不允许R小于原始子句最大数:") != string::npos)){
//            StrategyParam::Rsmall = false;
//            continue;
//        }
//        else if(str.find("允许R小于原始子句最大数:") != string::npos)
//        {
//            StrategyParam::Rsmall = true;
//            continue;
//        }
        if ((str.find("删除无法判定记录:") != string::npos)&&(str.find("不删除无法判定记录:") == string::npos)){
            StrategyParam::delRecord = true;
            continue;
        }
        else if(str.find("不删除无法判定记录:") != string::npos)
        {
            StrategyParam::delRecord = false;
            continue;
        }//
        if ((str.find("优先生成文字少的子句:") != string::npos)&&(str.find("不优先生成文字少的子句:") == string::npos)){
            StrategyParam::genLitClause = true;
            continue;
        }
        else if(str.find("不优先生成文字少的子句:") != string::npos)
        {
            StrategyParam::genLitClause = false;
            continue;
        }
        //StrategyParam::strategyMode
        if (str.find("多组合策略模式0") != string::npos){
             StrategyParam::strategyMode = 0;
            continue;
        }
        else if (str.find("多组合策略模式1") != string::npos){
             StrategyParam::strategyMode = 1;
            continue;
        }
        else if (str.find("多组合策略模式2") != string::npos) {
            StrategyParam::strategyMode = 0;
            continue;
        }
        //StrategyParam::noUintCla
        if (str.find("非单元子句限制策略0") != string::npos){
             StrategyParam::noUintCla = 0;
            continue;
        }
        else if (str.find("非单元子句限制策略1") != string::npos){
             StrategyParam::noUintCla = 1;
            continue;
        }
        else if (str.find("非单元子句限制策略2") != string::npos){
             StrategyParam::noUintCla = 2;
            continue;
        }
        else if (str.find("非单元子句限制策略3") != string::npos){
             StrategyParam::noUintCla = 3;
            continue;
        }
        else if (str.find("非单元子句限制策略4") != string::npos){
             StrategyParam::noUintCla = 4;
            continue;
        }
        else if (str.find("非单元子句限制策略5") != string::npos){
             StrategyParam::noUintCla = 5;
            continue;
        }
        else if (str.find("非单元子句限制策略6") != string::npos){
             StrategyParam::noUintCla = 6;
            continue;
        }
        else if (str.find("非单元子句限制策略7") != string::npos){
             StrategyParam::noUintCla = 7;
            continue;
        }
        else if (str.find("非单元子句限制策略8") != string::npos){
             StrategyParam::noUintCla = 8;
            continue;
        }
        
        if (str.find("目标深度模式0") != string::npos){
             StrategyParam::goalDeepth = 2;
            continue;
        }
        else if (str.find("目标深度模式1") != string::npos){
             StrategyParam::goalDeepth = 3;
            continue;
        }
        else if (str.find("目标深度模式2") != string::npos){
             StrategyParam::goalDeepth = 4;
            continue;
        }
        else if (str.find("目标深度模式3") != string::npos){
             StrategyParam::goalDeepth = 5;
            continue;
        }
        else if (str.find("目标深度模式4") != string::npos){
             StrategyParam::goalDeepth = 6;
            continue;
        }
        else if (str.find("目标深度模式5") != string::npos){
             StrategyParam::goalDeepth = 7;
            continue;
        }
        else if (str.find("目标深度模式6") != string::npos){
             StrategyParam::goalDeepth = 8;
            continue;
        }
        else if (str.find("目标深度模式7") != string::npos){
             StrategyParam::goalDeepth = 9;
            continue;
        }
        else if (str.find("目标深度模式8") != string::npos){
             StrategyParam::goalDeepth = 10;
            continue;
        }
        else if (str.find("目标深度模式9") != string::npos){
             StrategyParam::goalDeepth = 200;
            continue;
        }
        //锁子句约简
        if (str.find("锁子句约简模式0") != string::npos){
             StrategyParam::lockType = 1;
            continue;
        }
        else if (str.find("锁子句约简模式1") != string::npos){
             StrategyParam::lockType = 2;
            continue;
        }
        else if (str.find("锁子句约简模式2") != string::npos){
             StrategyParam::lockType = 3;
            continue;
        }
        else if (str.find("锁子句约简模式3") != string::npos){
             StrategyParam::lockType = 4;
            continue;
        }
        else if (str.find("锁子句约简模式4") != string::npos){
             StrategyParam::lockType = 5;
            continue;
        }
        else if (str.find("锁子句约简模式5") != string::npos){
             StrategyParam::lockType = 0;
            continue;
        }
        //项代换检查冗余StrategyParam::termReRedund
        if (str.find("冗余判断策略0") != string::npos){
             StrategyParam::termReRedund = true;
            continue;
        }
        else if (str.find("冗余判断策略1") != string::npos){
             StrategyParam::termReRedund = false;
            continue;
        }
    }
    fclose(fd);
}
//插入最后解析结果
void FileOp::insertInfo(string str ,double time_s,UINT32 triTotalTimes)
{
    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".info";
    ifstream ifFolFile(strInfoPath);
    vector<string> info;
    string strClause;
    while (getline(ifFolFile, strClause)) {
        info.push_back(strClause);
    }
    ifFolFile.close();
    remove(strInfoPath.c_str());
    PrintINFO(str);
    char saveTime[100];
    sprintf(saveTime,"%f",time_s);
    string strTime = "判定时间："+string(saveTime)+"秒";
    PrintINFO(strTime);
    char saveTimes[100];
    sprintf(saveTimes,"%u",triTotalTimes);
    string triTimes = "矛盾体个数："+ string(saveTimes);
    PrintINFO(triTimes);
    strClause = "****************";
    PrintINFO(strClause);
    for(UINT32 i = 0 ; i<info.size();i++)
        PrintINFO(info[i]);
}
void FileOp::copyAndDelOrgFile(string orgFile, string theoremFormat){
    ifstream fin(orgFile.c_str());
    
    size_t pos = orgFile.find_last_of('/');
    string strategyName = orgFile.substr(pos + 1);
    size_t posEnd = strategyName.find_last_of('.');
    string strategyNameNoExt = strategyName.substr(0, posEnd);

    string distFile = workSpace + "/unsat/" + strategyNameNoExt + "_" + JudgeFileFullNameNoExt + ".txt";
    ofstream fout(distFile.c_str());
    char str;
    while (fin.get(str)) {
        fout << str;
    }
    fin.close();
    fout.close();
    
    string strategyRecordFile = workSpace + "/unsat" + "/strategyRecord.txt";
    strategyRecord = new ofstream(strategyRecordFile.c_str(), ios::app);
    if(theoremFormat == "0")
        *strategyRecord << judgeOriginalFileName + ": " + distFile << endl;
    else
        *strategyRecord << JudgeFileFullNameNoExt + ": " + distFile << endl;
    strategyRecord->close();
}
