/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   Prover.cpp
 * Author: caof
 * 
 * Created on 2016年11月29日, 下午2:30
 */

#include "Prover.h"
#include "dataTypeDef.h"
#include<iostream>
#include<fstream>
#include"FileOp.h"
extern map<INT32, vector<INT32>> validPathOut;
//extern std::vector<Process> pids;
Prover::Prover() {
}

Prover::Prover(const Prover& orig) {
}

Prover::~Prover() {
}
   
bool fileExists(const std::string& filename) {
    std::ifstream file(filename);
    return file.good();
} 
//StrategyParam::orginalClaNum
void Prover::validOutUnsatPath() {
    vector<INT32> validR;
    validR.reserve(8);
    //map<INT32, vector<INT32>>::iterator it;

//    for(it=validPathOut.begin();it!=validPathOut.end();++it){
//        cout<<it->first<<endl;
//    }
    vector<INT32>* usedClauses = nullptr;
    //findEmpty
    usedClauses = &validPathOut[0];
    for(int i=0; i<usedClauses->size(); ++i){
        if(usedClauses->at(i) > StrategyParam::orginalClaNum){
            validR.push_back(usedClauses->at(i));
        }
    }
    for (int i = 0; i < validR.size(); ++i) {
        usedClauses = &validPathOut[validR[i]];
        for (int j = 0; j < usedClauses->size(); ++j) {
            if (usedClauses->at(j) > StrategyParam::orginalClaNum) {
                if(find(validR.begin(),validR.end(),usedClauses->at(j)) == validR.end())
                    validR.push_back(usedClauses->at(j));
            }
        }
    } 
    if(validR.empty()==false){
        string strProofComp = FileOp::g_OutputPath  + "/usedCluaseId.txt";
        ofstream* usedId = new ofstream(strProofComp.c_str(), ios::app);
        for (int i = 0; i < validR.size(); ++i) {
            *usedId << validR[i] << endl;
        }
        usedId->close();
    }
    string outFile = FileOp::g_OutputPath + "/" + FileOp::JudgeFileFullNameNoExt + ".out";
    ifstream ifFolFile(outFile);
    string outFileTptp = FileOp::g_OutputPath + "/" + FileOp::JudgeFileFullNameNoExt + ".valid";
    ofstream ofInfoStream(outFileTptp, ios::app);
  
    string strLine;
    bool outFlag = false;
    while (getline(ifFolFile, strLine)) {
        if (strLine[0] == '%' || strLine[0] == '#') {
            //空行和%--注释语句 不读取
            ofInfoStream << strLine << endl;
        }
        else if((strLine.find("cnf",0)!= -1) && (strLine.find("$",0)== -1)){
            int begPos = strLine.find_first_of("(") + 1;
            int endPos = strLine.find_first_of(",");
            INT32 claId = stoi(strLine.substr(begPos, endPos - begPos));
            if(find(validR.begin(),validR.end(),claId) != validR.end()){
                ofInfoStream << strLine << endl;
                outFlag = true;
            }
            else
               outFlag = false; 
            continue;
        }
        else if((strLine.find("cnf",0)!= -1) && (strLine.find("$",0)!= -1)){
            size_t pos = strLine.find('$');
            strLine = strLine.erase(pos,1);
            ofInfoStream << strLine << endl;
            outFlag = true;
            continue;
        }
        if(outFlag){
            ofInfoStream << strLine << endl;
        }
    }
    ifFolFile.close();
    ofInfoStream.close();
    validR.clear();
    vector<INT32>().swap(validR);
}

void Prover::validOutRelease(){
    map<INT32, vector<INT32>>::iterator it;

    for(it=validPathOut.begin();it!=validPathOut.end();++it){
        it->second.clear();
        vector<INT32>().swap(it->second);
        
    }
    map<INT32, vector<INT32>>().swap(validPathOut);
}

RESULT Prover::prover(bool isOrigalS)
{

    Formula fol;
    clock_t readFile = clock();
    fol.ReadPreFile();
    if(StrategyParam::orForCompition){
        StrategyParam::readPreTime = (double) (clock() - readFile) / (double) CLOCKS_PER_SEC;
    }
    
    //初始化原始子句集的属性值
    fol.initOrgClaSetAttr();
    //读取策略开始判定
     if(FileOp::strategyMode == 0)//人工模式
        FileOp::readStrategy();//读取策略文件
    else if(FileOp::strategyMode == 1){
        FileOp::readStrategyN(0);
    }
    //adjust timeLimit
    if (StrategyParam::orForCompition) {
        if ((FileOp::runMode != 0)&&(FileOp::runMode != 1)) {
            clock_t end = clock();
            double time_s = (double) (end - StrategyParam::start) / (double) CLOCKS_PER_SEC;
            StrategyParam::timeLimit = (StrategyParam::timeForceLimit - time_s - 10) / 60;
        }
        if ((FileOp::runMode == 0) || (FileOp::runMode == 1)) {
            if (StrategyParam::timeLimit * 60 > (StrategyParam::timeForceLimit - 1)) {
                clock_t end = clock();
                double time_s = (double) (end - StrategyParam::start) / (double) CLOCKS_PER_SEC;
                StrategyParam::timeLimit = (StrategyParam::timeForceLimit - time_s - 10) / 60;
                StrategyParam::timeLimitStrategies = StrategyParam::timeLimit;
            }
        }
    }
    else{
        StrategyParam::timeLimitStrategies = StrategyParam::timeLimit;
        StrategyParam::timeForceLimit = StrategyParam::timeLimit;
        StrategyParam::firstTimeLimit = StrategyParam::timeLimit;
    } 
    
    
    if (fol.setCla.size() == 0)
        return READERR;
     //根据策略是否需要调整项序
    if (StrategyParam::termRewriting != 2) {
        for (auto& cla : fol.setOriClas) {
            cla->directEqn();
        }
    }
    //*FileOp::ofOutput << "%File   :mcs-scs 0.1" << endl;
    //*FileOp::ofOutput << "%Problem:" + FileOp::JudgeFileFullNameNoExt << endl;
    if (!StrategyParam::orForCompition)
        cout<<"开始判定:"<<FileOp::JudgeFileName<<endl;
    
    time_t startTime;
    time(&startTime);
    if (!StrategyParam::orForCompition)
        cout<<"开始时间:"<<ctime(&startTime)<<endl;
    clock_t startA;//用于设定时间
    startA = clock();
        double useT=0.0;
    double time_rets;
    Resolution res;
    UINT64 triTotalTimes = 0;
    RESULT rst;
    bool UNSATrst=false;
    bool UnSatRst=false;
    Clause* newClaNoInside=nullptr;
       string resdata=FileOp::g_OutputPath+"/Resdata.txt";
        ofstream* delRecor=new ofstream(resdata.c_str(),ios::app);
    if(StrategyParam::useSaturate){
        rst = res.BaseAlgByRecodePathSaturate(fol,triTotalTimes); //使用记录路径的方式进行路径回退
    }
    else
    {//
       
          clock_t rstend = clock();
                  time_rets = (double) (rstend-startA) / (double) CLOCKS_PER_SEC;
                  * delRecor<<"_185_"<<triTotalTimes<<endl;
       //     cout<<"_182_"<<triTotalTimes<<endl;
        rst = res.BaseAlgByRecodePathInzgy(fol,triTotalTimes); //使用记录路径的方式进行路径回退
        
     * delRecor<<"_192_"<<endl;
         string UseTime1 = FileOp::g_OutputPath + "/Usetime.txt";
          * delRecor<<"_194_"<<UseTime1<<endl;
//          sleep(10);
             ifstream fin(UseTime1);
    string strLine = "";
    while (getline(fin, strLine)) {
           if (strLine.find("usedTime:") != string::npos) {
            size_t begPos = strLine.find("usedTime:");
            begPos += 9;
//            size_t endPos = strLine.find_first_of("v7.");
//            endPos +=  3;
             useT = stold(strLine.substr(begPos));
           * delRecor<<"_363useT_"<<useT<<endl;  
//           sleep(15);
          //   findFlag = true;
            break;
        }
        
    }
    
        if(0&&res.D1D2UnitnewClaTotal.size()>0){
 * delRecor<<"_188_"<<to_string(rst)<<"+"<<getpid()<<"+"<<triTotalTimes<<endl;
   for(auto&newCla1:res.D1D2UnitnewClaTotal){
       if(find(res.D1UnitnewClaTotal.begin(),res.D1UnitnewClaTotal.end(),newCla1)!=res.D1UnitnewClaTotal.end()&&
               (!newCla1->LitPtr[0]->Inside)){
           newClaNoInside=newCla1;
                         * delRecor<<"_195_"<<newCla1->uClaId<<"+"<<newCla1->LitPtr[0]->Inside<<endl;
       }
                    }
 
 //条件还需要改一下：如果是没有加入的子句参与演绎呢 这种怎么判断
         for(auto&cl:fol.setCla){
if(find(res.D1D2UnitnewClaTotal.begin(),res.D1D2UnitnewClaTotal.end(),cl)!=res.D1D2UnitnewClaTotal.end()){
   
    if(find(res.D1UnitnewClaTotal.begin(),res.D1UnitnewClaTotal.end(),cl)!=res.D1UnitnewClaTotal.end()
            &&cl->LitPtr[0]->Inside){
         * delRecor<<"_s202_"<<cl->uClaId<<"+"<< newClaNoInside->uClaId<<endl;
        UNSATrst=true;
    }
    else if(find(res.D1UnitnewClaTotal.begin(),res.D1UnitnewClaTotal.end(),cl)!=res.D1UnitnewClaTotal.end()
            &&(!cl->LitPtr[0]->Inside)){
        * delRecor<<"_n206_"<<cl->uClaId<<endl;
        UnSatRst=true;
        UNSATrst=false;
    }
    if(find(res.D2UnitnewClaTotal.begin(),res.D2UnitnewClaTotal.end(),cl)!=res.D2UnitnewClaTotal.end()&&
            cl->LitPtr[0]->Inside&&UnSatRst){
        * delRecor<<"_s209_"<<cl->uClaId<<"+"<< newClaNoInside->uClaId<<endl;
           UNSATrst=true;
    }
                      * delRecor<<getpid()<<"+"<<"sucess+"<<cl->uClaId<<"+"<<cl->uLitNum<<endl;
                 }


                      }
                  cout<<"_186_"<<triTotalTimes<<endl;
                    * delRecor<<"_194_"<<triTotalTimes<<endl;
        }          
    }
        
//    }
    
//    if(fol.setHasBindTerm()){
//        cout<<"未清空替换项"<<endl;
//    }
    if(0&&(rst == UNSAT)&&res.D1D2UnitnewClaTotal.size()>0&&UNSATrst&& (StrategyParam::problemDiv == 0)){//zgy 2023-7-19
        clock_t end = clock();
//        double time_s = (double) (end - StrategyParam::start) / (double) CLOCKS_PER_SEC;
        
           double time_s;
     if(getpid()!=res.ForwardId){
  * delRecor<<"_264_"<<to_string((double)(res.ForwardTime+clock()-StrategyParam::start)/(double) CLOCKS_PER_SEC)<<"+"<<res.ForwardId<<"+"
                               <<to_string(res.ForwardTime)<<endl;
   time_s = (double) (end - StrategyParam::start) / (double) CLOCKS_PER_SEC+(double)(res.ForwardTime);
    * delRecor<<"_270_"<<to_string(time_s )<<endl;
              
         }
     else{
           time_s = (double) (end - StrategyParam::start) / (double) CLOCKS_PER_SEC;
            * delRecor<<"_274_"<<to_string(time_s )<<endl;
     }
        if((FileOp::runMode != 0 )&&(FileOp::runMode != 1)){
            time_s += StrategyParam::firstRunTime;
        }
        time_s = fabs(time_s);
        *FileOp::ofJudgeAllFileResult << FileOp::JudgeFileName << ":不可满足!"<<endl;
        string str = "判定结论：不可满足！";
        FileOp::insertInfo(str,time_s,triTotalTimes);
        if(StrategyParam::orForCompition) {
            cout << "%-------------------------------------------" << endl;

            cout << "% File        :CSI_E---1.0" << endl;
            cout << "% Problem     :" + FileOp::judgeOriginalFileName << endl;
            cout << "% Transform   :cnf" << endl;
            cout << "% Format      :tptp:raw" << endl;
            cout << "% Command     :java -jar mcs_epr.jar %d %s" << endl;
            cout << endl;
            cout << "% Result      :Theorem " + to_string(time_s) + "s" << endl;
            cout << "% Output      :CNFRefutation " + to_string(time_s) + "s" << endl;
            cout << "%-------------------------------------------" << endl;
            string cmdFileOut1 = "cat " + FileOp::judgeOriginalFileFullName;
            int res1 = system(const_cast<char*> (cmdFileOut1.c_str()));
            cout << "%-------------------------------------------" << endl;
            cout << "% Proof found" << endl;
            cout << "% SZS status Theorem for " + FileOp::judgeOriginalFileName << endl;
            cout << "% SZS output start Proof" << endl;
            string cmdFileOut2 = "cat " + FileOp::g_WorkDir + "/" + FileOp::JudgeFileFullNameNoExt + ".pre";
            int res2 = system(const_cast<char*> (cmdFileOut2.c_str()));
            cout << "%-------------------------------------------" << endl;
            validOutUnsatPath();
            string cmdFileOut3 = "cat " + FileOp::g_OutputPath + "/" + FileOp::JudgeFileFullNameNoExt + ".valid";
            int res3 = system(const_cast<char*> (cmdFileOut3.c_str()));
            validOutRelease();
            cout << "% SZS output end Proof" << endl;
            cout << "% Total time :" + to_string(time_s) + "s" << endl;
        }
        
        string strProofComp = FileOp::appPath + "/proofStatistics.txt";
        FileOp::ofProofComp = new ofstream(strProofComp.c_str(), ios::app);
        if(StrategyParam::orForCompition)
            *FileOp::ofProofComp << FileOp::judgeOriginalFileName + ": " + to_string(time_s) <<endl;
        else
            *FileOp::ofProofComp << FileOp::JudgeFileFullNameNoExt + ": " + to_string(time_s) <<endl;
        FileOp::ofProofComp->close();
        
        
    }
    
    else if(0&&(rst == UNSAT)&&res.D1D2UnitnewClaTotal.size()<1&& (StrategyParam::problemDiv == 0)){//zgy 2023-7-19
        clock_t end = clock();
        double time_s = (double) (end - StrategyParam::start) / (double) CLOCKS_PER_SEC;
        if((FileOp::runMode != 0 )&&(FileOp::runMode != 1)){
            time_s += StrategyParam::firstRunTime;
        }
        time_s = fabs(time_s);
        *FileOp::ofJudgeAllFileResult << FileOp::JudgeFileName << ":不可满足!"<<endl;
        string str = "判定结论：不可满足！";
        FileOp::insertInfo(str,time_s,triTotalTimes);
        if(StrategyParam::orForCompition) {
            cout << "%-------------------------------------------" << endl;

            cout << "% File        :CSI_E---1.0" << endl;
            cout << "% Problem     :" + FileOp::judgeOriginalFileName << endl;
            cout << "% Transform   :cnf" << endl;
            cout << "% Format      :tptp:raw" << endl;
            cout << "% Command     :java -jar mcs_epr.jar %d %s" << endl;
            cout << endl;
            cout << "% Result      :Theorem " + to_string(time_s) + "s" << endl;
            cout << "% Output      :CNFRefutation " + to_string(time_s) + "s" << endl;
            cout << "%-------------------------------------------" << endl;
            string cmdFileOut1 = "cat " + FileOp::judgeOriginalFileFullName;
            int res1 = system(const_cast<char*> (cmdFileOut1.c_str()));
            cout << "%-------------------------------------------" << endl;
            cout << "% Proof found" << endl;
            cout << "% SZS status Theorem for " + FileOp::judgeOriginalFileName << endl;
            cout << "% SZS output start Proof" << endl;
            string cmdFileOut2 = "cat " + FileOp::g_WorkDir + "/" + FileOp::JudgeFileFullNameNoExt + ".pre";
            int res2 = system(const_cast<char*> (cmdFileOut2.c_str()));
            cout << "%-------------------------------------------" << endl;
            validOutUnsatPath();
            string cmdFileOut3 = "cat " + FileOp::g_OutputPath + "/" + FileOp::JudgeFileFullNameNoExt + ".valid";
            int res3 = system(const_cast<char*> (cmdFileOut3.c_str()));
            validOutRelease();
            cout << "% SZS output end Proof" << endl;
            cout << "% Total time :" + to_string(time_s) + "s" << endl;
        }
        
        string strProofComp = FileOp::appPath + "/proofStatistics.txt";
        FileOp::ofProofComp = new ofstream(strProofComp.c_str(), ios::app);
        if(StrategyParam::orForCompition)
            *FileOp::ofProofComp << FileOp::judgeOriginalFileName + ": " + to_string(time_s) <<endl;
        else
            *FileOp::ofProofComp << FileOp::JudgeFileFullNameNoExt + ": " + to_string(time_s) <<endl;
        FileOp::ofProofComp->close();
        
        
    }
    else if((rst == SAT) && (!StrategyParam::orForCompition) ){ 
        *FileOp::ofJudgeAllFileResult << FileOp::JudgeFileName << ":可满足!"<<endl;
    }
    else if(((rst == UNSAT)||rst==100)&& (StrategyParam::problemDiv == 0))
    {
         
//      cout<<"_352_"<<triTotalTimes<<endl;
        clock_t end = clock();
        double time_s = (double) (end - StrategyParam::start) / (double) CLOCKS_PER_SEC;
//        cout<<"_355_"<<triTotalTimes<<endl;
        if((FileOp::runMode != 0 )&&(FileOp::runMode != 1)){
            time_s += StrategyParam::firstRunTime;
//            cout<<"_358_"<<triTotalTimes<<endl;
        }
//         cout<<"_359_"<<triTotalTimes<<endl;
        time_s = fabs(time_s);
//         cout<<"_360_"<<triTotalTimes<<":"<<rst<<"+"<<StrategyParam::problemDiv<<endl;
        if(0&&int(time_s)<300){
             clock_t rstend1 = clock();
                  time_rets = (double) (rstend1-startA) / (double) CLOCKS_PER_SEC;
               
                        set<Clause*>::iterator claP_it = fol.setCla.begin();
                        Clause* newIDCla=nullptr;
                        for(auto&decla:fol.setCla){
                             if(find(res.D1D2UnitnewClaTotal.begin(),res.D1D2UnitnewClaTotal.end(),decla)!=res.D1D2UnitnewClaTotal.end()){
                       newIDCla=decla;
                           for (; claP_it != fol.setCla.end();) {
//  if(find(res.D1D2UnitnewClaTotal.begin(),res.D1D2UnitnewClaTotal.end(),(*claP_it))!=res.D1D2UnitnewClaTotal.end()){
                      if ((*claP_it)==newIDCla) {//(*claP_it) ==newID
                          
                         if(claP_it != fol.setCla.end()){
                             
                    claP_it = fol.setCla.erase(claP_it);
                      
* delRecor<<"_delete359:"<<newIDCla->uClaId<<endl;
                   } 
                     }
                      else{
                      ++claP_it;
                      }
  
              
                    }
                             }
                        }
                
                  
             rst = res.BaseAlgByRecodePath(fol,triTotalTimes); //使用记录路径的方式进行路径回退
        }
          if(((rst == UNSAT)||rst==100)&& (StrategyParam::problemDiv == 0)){//zgy 2023-7-19
//               cout<<"_393_"<<triTotalTimes<<endl;
        clock_t end = clock();
      //   store_process();
        double time_s = (double) (end - StrategyParam::start) / (double) CLOCKS_PER_SEC;
        if((FileOp::runMode != 0 )&&(FileOp::runMode != 1)){
            time_s += StrategyParam::firstRunTime;
        }
//         cout<<"_401_"<<triTotalTimes<<endl;
         if(useT>0.0){
        time_s = fabs(useT);
         }
         else{
             time_s = fabs(time_s); 
         }
//         cout<<"_400_"<<triTotalTimes<<endl;
        *FileOp::ofJudgeAllFileResult << FileOp::JudgeFileName << ":不可满足!"<<endl;
        string str = "判定结论：不可满足！";
        FileOp::insertInfo(str,time_s,triTotalTimes);
            
            if(1){
                  string proces=FileOp::g_OutputPath +"/Process.txt";
                      std::string destFilePath = FileOp::g_OutputPath + "/" + FileOp::JudgeFileFullNameNoExt + ".out";
                if (!fileExists(proces)){
                    string outid=FileOp::g_OutputPath + "/"  +FileOp::JudgeFileFullNameNoExt+"process_" + std::to_string(getpid()) + ".outid";
                    if(fileExists(outid)){
                        
                           std::string cmdFileOut3 = "cat " + outid+ " > " + destFilePath;
                             cout<<cmdFileOut3<<endl;
                            
                               int res4 = system(cmdFileOut3.c_str()); 
                                 *FileOp::ofJudgeAllFileResult<<"_481_"<<cmdFileOut3<<endl;
               // printout=false;
                    }
                    
                }
 
            }
        if(StrategyParam::orForCompition) {
            cout << "%-------------------------------------------" << endl;

            cout << "% File        :CSI_E---1.0" << endl;
            cout << "% Problem     :" + FileOp::judgeOriginalFileName << endl;
            cout << "% Transform   :cnf" << endl;
            cout << "% Format      :tptp:raw" << endl;
            cout << "% Command     :java -jar mcs_epr.jar %d %s" << endl;
            cout << endl;
            cout << "% Result      :Theorem " + to_string(time_s) + "s" << endl;
            cout << "% Output      :CNFRefutation " + to_string(time_s) + "s" << endl;
            cout << "%-------------------------------------------" << endl;
            string cmdFileOut1 = "cat " + FileOp::judgeOriginalFileFullName;
            int res1 = system(const_cast<char*> (cmdFileOut1.c_str()));
            cout << "%-------------------------------------------" << endl;
            cout << "% Proof found" << endl;
            cout << "% SZS status Theorem for " + FileOp::judgeOriginalFileName << endl;
            cout << "% SZS output start Proof" << endl;
            string cmdFileOut2 = "cat " + FileOp::g_WorkDir + "/" + FileOp::JudgeFileFullNameNoExt + ".pre";
            int res2 = system(const_cast<char*> (cmdFileOut2.c_str()));
            cout << "%-------------------------------------------" << endl;
        
    if(1){
                  string proces=FileOp::g_OutputPath +"/Process.txt";
                      std::string destFilePath = FileOp::g_OutputPath + "/" + FileOp::JudgeFileFullNameNoExt + ".out";
                if (!fileExists(proces)){
                    string outid=FileOp::g_OutputPath + "/"  +FileOp::JudgeFileFullNameNoExt+"process_" + std::to_string(getpid()) + ".outid";
                    if(fileExists(outid)){
                        
                           std::string cmdFileOut3 = "cat " + outid;
                           //  cout<<cmdFileOut3<<endl;
                            
                               int res4 = system(cmdFileOut3.c_str()); 
                                 std::string cmdFileOut5 = "cat " +  outid+ " > " + destFilePath;
                                   int res5 = system(cmdFileOut5.c_str());
                               //  *FileOp::ofJudgeAllFileResult<<"_481_"<<cmdFileOut3<<endl;
               // printout=false;
                    }
                    
                }
 
            }
            
            validOutUnsatPath();
            string cmdFileOut3 = "cat " + FileOp::g_OutputPath + "/" + FileOp::JudgeFileFullNameNoExt + ".valid";
            string cmdFileOutvalid = FileOp::g_OutputPath + "/" + FileOp::JudgeFileFullNameNoExt + ".validid";
             ofstream* ofInfoStream =new ofstream(cmdFileOutvalid.c_str(),ios::app);
      std::vector<Process> processes = read_processes();
    print_processes(processes);
       *ofInfoStream<<processes.size()<<"_id_"<<to_string(getpid())<<"_globalVariable_"<<globalVariable<<endl;
         string cmdFileOutvalid1 = FileOp::g_OutputPath + "/" + FileOp::JudgeFileFullNameNoExt + ".validid1";
          std::ifstream fileid(cmdFileOutvalid1);
           std::string searchString = "globalVariable";

           std::string lineid;
    while (std::getline(fileid, lineid)) {
        size_t pos = lineid.find(searchString);
        if (pos != std::string::npos) {
            // 截取searchString后面的内容
            *ofInfoStream<<"_485_"<<lineid.substr(pos + searchString.length())<<endl;
           globalVariable= stoi(lineid.substr(pos + searchString.length()));
            *ofInfoStream<<"_globalVariable_"<<globalVariable<<endl;
        }
    }
      // 查找文件
    std::string dir = FileOp::g_OutputPath ;//".";
    *ofInfoStream<<dir<<endl;
     // 构建源文件路径
      std::string srcFilePath = " ";
        std::string srcFilePath2 = " ";
         std::string srcFilePath3= " ";
         int mdID=0;
      bool printout=true;
     // 构建目标文件路径
    std::string destFilePath = FileOp::g_OutputPath + "/" + FileOp::JudgeFileFullNameNoExt + ".out";
    if(printout&&processes.size()==0){
            
             srcFilePath2= FileOp::g_OutputPath + "/"  +FileOp::JudgeFileFullNameNoExt+"process_" + to_string(getpid()) + ".outid";
          std::string cmdFileOut3 = "cat " +  srcFilePath2+ " > " + destFilePath;
           std::string cmdFileOut4 = "cat " +  srcFilePath2;
            *ofInfoStream << "Executing command: " << cmdFileOut3 << std::endl;
           // 执行命令
    int res3 = system(cmdFileOut3.c_str()); 
     int res4 = system(cmdFileOut4.c_str()); 
                printout=false;
        }
    for (const auto& process : processes) {
         *ofInfoStream<<dir<<endl;
          *ofInfoStream<<process.pid<<endl;
            *ofInfoStream<<process.parent_pid<<endl;
        std::vector<std::string> files = find_files_with_pid(dir, process.pid, process.parent_pid);
        *ofInfoStream << "Files for PID " << process.pid << " and Parent PID " << process.parent_pid<<"_files"<<files.size() << ":\n";
        if(printout&&files.size()>0){
            if(process.pid==globalVariable){
       // srcFilePath=FileOp::g_OutputPath + "/"+file;
            
        srcFilePath= FileOp::g_OutputPath + "/"  +FileOp::JudgeFileFullNameNoExt+"process_" + to_string(process.parent_pid) + ".outid";
         srcFilePath2= FileOp::g_OutputPath + "/"  +FileOp::JudgeFileFullNameNoExt+"process_" + to_string(process.pid) + ".outid";
         mdID=process.parent_pid;
         if(1){
             
                 for (const auto& process : processes) {
                     if(mdID==process.pid){
                          srcFilePath3= FileOp::g_OutputPath + "/"  +FileOp::JudgeFileFullNameNoExt+"process_" + to_string(process.parent_pid) + ".outid";
                          *ofInfoStream <<"_530_"<< srcFilePath3<<endl;
                         
                     }
             
             
             
                 }
         }
         if (fileExists(srcFilePath)&&fileExists(srcFilePath2)&&fileExists(srcFilePath3)) {
         std::string cmdFileOut2 = "cat " +  srcFilePath3+ " "+srcFilePath2+" "+srcFilePath+" > " + destFilePath;
            std::string cmdFileOut21 = "cat " +  srcFilePath3+" "+srcFilePath2+" "+srcFilePath;
            *ofInfoStream << "Executing command: " << cmdFileOut2 << std::endl;
           // 执行命令
    int res2 = system(cmdFileOut2.c_str()); 
     int res21 = system(cmdFileOut21.c_str()); 
     
     if(0){
          std::string cmdFileOut3 = "cat " +  srcFilePath2+ " > " + destFilePath;
          std::string cmdFileOut31 = "cat " +  srcFilePath2;
            *ofInfoStream << "Executing command: " << cmdFileOut3 << std::endl;
           // 执行命令
    int res3 = system(cmdFileOut3.c_str()); 
    int res31 = system(cmdFileOut31.c_str());
        }
    printout=false;
        }
         else if (fileExists(srcFilePath)&&fileExists(srcFilePath2)&&(!fileExists(srcFilePath3))) {
         std::string cmdFileOut2 = "cat " +  srcFilePath+ " "+srcFilePath2+" > " + destFilePath;
            std::string cmdFileOut21 = "cat " +  srcFilePath+" "+srcFilePath2;
            *ofInfoStream << "Executing command: " << cmdFileOut2 << std::endl;
           // 执行命令
    int res2 = system(cmdFileOut2.c_str()); 
     int res21 = system(cmdFileOut21.c_str()); 
     
     if(0){
          std::string cmdFileOut3 = "cat " +  srcFilePath2+ " > " + destFilePath;
          std::string cmdFileOut31 = "cat " +  srcFilePath2;
            *ofInfoStream << "Executing command: " << cmdFileOut3 << std::endl;
           // 执行命令
    int res3 = system(cmdFileOut3.c_str()); 
    int res31 = system(cmdFileOut31.c_str());
        }
    printout=false;
        }
         
        }
    }
      
        for (const auto& file : files) {
         *ofInfoStream<< " _f_ " << file << "\n";
           // 输出命令以便调试（可选）
 
        // string outFile1 = "cat " +file;//FileOp::g_OutputPath + "/" + FileOp::JudgeFileFullNameNoExt +process.parent_pid+ ".outid";
           //  int res4 = system(const_cast<char*> (outFile1.c_str()));
        }
    }
            int res3 = system(const_cast<char*> (cmdFileOut3.c_str()));
           
            validOutRelease();
            cout << "% SZS output end Proof" << endl;
            cout << "% Total time :" + to_string(time_s) + "s" << endl;
        }
        
        string strProofComp = FileOp::appPath + "/proofStatistics.txt";
        FileOp::ofProofComp = new ofstream(strProofComp.c_str(), ios::app);
        if(StrategyParam::orForCompition)
            *FileOp::ofProofComp << FileOp::judgeOriginalFileName + ": " + to_string(time_s) <<endl;
        else
            *FileOp::ofProofComp << FileOp::JudgeFileFullNameNoExt + ": " + to_string(time_s) <<endl;
        FileOp::ofProofComp->close();
        
        
    }
        }
    else if(StrategyParam::preprocess){
        cout<<"_449_"<<endl;
        ;
    }
   
    else{//UNKNOWN 根据徐老师建议，若无法判定，则删除判定文件夹，这里加上开关
           string delRecord1=FileOp::g_OutputPath+"/delRecorddata.txt";
        ofstream* delRecord1data=new ofstream(delRecord1.c_str(),ios::app);
        if((StrategyParam::orForCompition) && (FileOp::runMode < 2)){// all deleted
            * delRecord1data<<"-241-";
            cout<<"-241-";
            FileOp::delAllFilesComplete(FileOp::g_OutputPath);
            rmdir(FileOp::g_OutputPath.c_str());
            remove(FileOp::g_PreFileFullName.c_str()); //需要利用pre文件找到目标子句
        }
        else if(/*(StrategyParam::orForCompition) &&*/ (FileOp::runMode > 1)){
            cout<<"-249-";
            * delRecord1data<<"-247-";
            ;
        }
        else if(StrategyParam::delRecord){//FileOp::JudgeFileFullName
            * delRecord1data<<"-251-";
            cout<<"-251-";
            FileOp::delAllFiles();
            if ((StrategyParam::useCombinedSys == 0) && (FileOp::runMode < 2)) {
//                * delRecord1data<<"-254-";
                cout<<"-254-";
                rmdir(FileOp::g_OutputPath.c_str());
                remove(FileOp::g_PreFileFullName.c_str()); //需要利用pre文件找到目标子句
            }
        }
        
        *FileOp::ofJudgeAllFileResult << FileOp::JudgeFileName << "无法判定!"<<endl;
        if((StrategyParam::orForCompition) && ((FileOp::runMode == 0 )||(FileOp::runMode == 1))){
            string strProofComp = FileOp::appPath + "/proofStatistics.txt";
            FileOp::ofProofComp = new ofstream(strProofComp.c_str(), ios::app);
            if(StrategyParam::orForCompition)
                *FileOp::ofProofComp << FileOp::judgeOriginalFileName + " :TMO‑Non" << endl;
            else
                *FileOp::ofProofComp << FileOp::JudgeFileFullNameNoExt + " :TMO‑Non" << endl;
            FileOp::ofProofComp->close();
        }
         delRecord1data->close();
    }
    
    
    //to geoff test
    if(1){
        FileOp::delRunFiles();
    }
    
    
    FileOp::ReleaseOf();
    fol.DelSet();//20170807
    return rst;
}
RESULT Prover::proverTestTptp(int strategyId)
{
    
    Formula fol;
    clock_t readFile = clock();
    fol.ReadPreFile();
    if(StrategyParam::orForCompition){
        StrategyParam::readPreTime = (double) (clock() - readFile) / (double) CLOCKS_PER_SEC;
    }
    
    //初始化原始子句集的属性值
    fol.initOrgClaSetAttr();
    //读取策略开始判定

    FileOp::readStrategyNTptp(strategyId);
    
    
    //adjust timeLimit
    if (StrategyParam::orForCompition) {
        if ((FileOp::runMode != 0)&&(FileOp::runMode != 1)) {
            clock_t end = clock();
            double time_s = (double) (end - StrategyParam::start) / (double) CLOCKS_PER_SEC;
            StrategyParam::timeLimit = (StrategyParam::timeForceLimit - time_s - 10) / 60;
        }
        if ((FileOp::runMode == 0) || (FileOp::runMode == 1)) {
            if (StrategyParam::timeLimit * 60 > (StrategyParam::timeForceLimit - 1)) {
                clock_t end = clock();
                double time_s = (double) (end - StrategyParam::start) / (double) CLOCKS_PER_SEC;
                StrategyParam::timeLimit = (StrategyParam::timeForceLimit - time_s - 10) / 60;
                StrategyParam::timeLimitStrategies = StrategyParam::timeLimit;
            }
        }
    }
    else{
        StrategyParam::timeLimitStrategies = StrategyParam::timeLimit;
        StrategyParam::timeForceLimit = StrategyParam::timeLimit;
        StrategyParam::firstTimeLimit = StrategyParam::timeLimit;
    } 
    
    
    if (fol.setCla.size() == 0)
        return READERR;
     //根据策略是否需要调整项序
    if (StrategyParam::termRewriting != 2) {
        for (auto& cla : fol.setOriClas) {
            cla->directEqn();
        }
    }
    //*FileOp::ofOutput << "%File   :mcs-scs 0.1" << endl;
    //*FileOp::ofOutput << "%Problem:" + FileOp::JudgeFileFullNameNoExt << endl;
    if ((!StrategyParam::orForCompition) && (strategyId == 0) && (FileOp::strategyMode == 3))
        cout<<"开始判定:"<<FileOp::JudgeFileName<<endl;
    else if ((!StrategyParam::orForCompition) && (FileOp::strategyMode == 4))
        cout<<"开始判定:"<<FileOp::JudgeFileName<<endl;
    time_t startTime;
    time(&startTime);
    if (!StrategyParam::orForCompition)
        cout<<"开始时间:"<<ctime(&startTime)<<endl;
    clock_t startA;//用于设定时间
    startA = clock();
     double time_rets;
    Resolution res;
    UINT64 triTotalTimes = 0;
    RESULT rst;
    //cout<< "scs deduction is in"<<endl;
    //cout<< " total numbers:Debug11"  << endl;
    if(StrategyParam::useSaturate){
        rst = res.BaseAlgByRecodePathSaturate(fol,triTotalTimes); //使用记录路径的方式进行路径回退
    }
    else
    {// //首先用正向  然后再用逆向 三角形的个数与分配正逆向有关
  if(triTotalTimes%10>5){
            cout<<"_373_"<<triTotalTimes<<endl;
        rst = res.BaseAlgByRecodePathInzgy(fol,triTotalTimes); //使用记录路径的方式进行路径回退
        }
        else{
            cout<<"_377_"<<triTotalTimes<<endl;
         rst = res.BaseAlgByRecodePath(fol,triTotalTimes); //使用记录路径的方式进行路径回退
        }
    }
           
    //cout<< " total numbers:Debug111"  << endl;
//    if(fol.setHasBindTerm()){
//        cout<<"未清空替换项"<<endl;
//    }
    //cout<< "scs deduction is exit"<<endl;
    if(rst == UNSAT){
        clock_t end = clock();
        double time_s = (double) (end - StrategyParam::start) / (double) CLOCKS_PER_SEC;
        if((FileOp::runMode != 0 )&&(FileOp::runMode != 1)){
            time_s += StrategyParam::firstRunTime;
        }
        time_s = fabs(time_s);
        *FileOp::ofJudgeAllFileResult << FileOp::JudgeFileName << ":不可满足!"<<endl;
        string str = "判定结论：不可满足！";
        FileOp::insertInfo(str,time_s,triTotalTimes);
        if(StrategyParam::orForCompition) {
            cout << "%-------------------------------------------" << endl;

            cout << "% File        :CSE---1.0" << endl;
            cout << "% Problem     :" + FileOp::judgeOriginalFileName << endl;
            cout << "% Transform   :cnf" << endl;
            cout << "% Format      :tptp:raw" << endl;
            cout << "% Command     :java -jar mcs_scs.jar %d %s" << endl;
            cout << endl;
            cout << "% Result      :Theorem " + to_string(time_s) + "s" << endl;
            cout << "% Output      :CNFRefutation " + to_string(time_s) + "s" << endl;
            cout << "%-------------------------------------------" << endl;
            string cmdFileOut1 = "cat " + FileOp::judgeOriginalFileFullName;
            int res1 = system(const_cast<char*> (cmdFileOut1.c_str()));
            cout << "%-------------------------------------------" << endl;
            cout << "% Proof found" << endl;
            cout << "% SZS status Theorem for " + FileOp::judgeOriginalFileName << endl;
            cout << "% SZS output start Proof" << endl;
            string cmdFileOut2 = "cat " + FileOp::g_WorkDir + "/" + FileOp::JudgeFileFullNameNoExt + ".pre";
            int res2 = system(const_cast<char*> (cmdFileOut2.c_str()));
            cout << "%-------------------------------------------" << endl;
            validOutUnsatPath();
            string cmdFileOut3 = "cat " + FileOp::g_OutputPath + "/" + FileOp::JudgeFileFullNameNoExt + ".valid";
            int res3 = system(const_cast<char*> (cmdFileOut3.c_str()));
            validOutRelease();
            cout << "% SZS output end Proof" << endl;
            cout << "% Total time :" + to_string(time_s) + "s" << endl;
        }
        
        string strProofComp = FileOp::appPath + "/proofStatistics.txt";
        FileOp::ofProofComp = new ofstream(strProofComp.c_str(), ios::app);
        if(StrategyParam::orForCompition)
            *FileOp::ofProofComp << FileOp::judgeOriginalFileName + ": " + to_string(time_s) <<endl;
        else
            *FileOp::ofProofComp << FileOp::JudgeFileFullNameNoExt + ": " + to_string(time_s) <<endl;
        FileOp::ofProofComp->close();
        
        
    }
    else if((rst == SAT) && (!StrategyParam::orForCompition)){ 
        *FileOp::ofJudgeAllFileResult << FileOp::JudgeFileName << ":可满足!"<<endl;
    }
    else{
        
           string delRecord2=FileOp::g_OutputPath+"/delRecorddata2.txt";
        ofstream* delRecord1data2=new ofstream(delRecord2.c_str(),ios::app);
        //UNKNOWN 根据徐老师建议，若无法判定，则删除判定文件夹，这里加上开关
        if((StrategyParam::orForCompition) && (FileOp::runMode < 2)){// all deleted
            if(FileOp::strategyMode == 3) {
                 * delRecord1data2<<"-416-";
                 cout<<"-416-";
                FileOp::delRunFiles();
                if(strategyId == FileOp::strategyFileSize) {
                    FileOp::delAllFilesComplete(FileOp::g_OutputPath);
                    rmdir(FileOp::g_OutputPath.c_str());

                    remove(FileOp::g_PreFileFullName.c_str()); //需要利用pre文件找到目标子句
                }
            } else {
                  * delRecord1data2<<"-426-";
                  cout<<"-426-";
                FileOp::delAllFilesComplete(FileOp::g_OutputPath);
                rmdir(FileOp::g_OutputPath.c_str());

                remove(FileOp::g_PreFileFullName.c_str()); //需要利用pre文件找到目标子句
            }
        }
        else if(/*(StrategyParam::orForCompition) &&*/ (FileOp::runMode > 1)){
            ;
        }
        else if(StrategyParam::delRecord){//FileOp::JudgeFileFullName
            if(strategyId != FileOp::strategyFileSize-1){
                 * delRecord1data2<<"-436-";
                  cout<<"-436-";
                FileOp::delRunFiles();
            }
            else if(strategyId == FileOp::strategyFileSize-1){
                  * delRecord1data2<<"-442-";
                   cout<<"-442-";
                FileOp::delAllFiles();
            }
            if ((StrategyParam::useCombinedSys == 0) && (FileOp::runMode < 2)) {
                rmdir(FileOp::g_OutputPath.c_str());
                if(strategyId == FileOp::strategyFileSize-1){
                    remove(FileOp::g_PreFileFullName.c_str()); //需要利用pre文件找到目标子句
                    cout << "无法判定" << endl;
                }
            }
        }
        *FileOp::ofJudgeAllFileResult << FileOp::JudgeFileName << "无法判定!"<<endl;
        if((StrategyParam::orForCompition) && ((FileOp::runMode == 0 )||(FileOp::runMode == 1))){
            string strProofComp = FileOp::appPath + "/proofStatistics.txt";
            FileOp::ofProofComp = new ofstream(strProofComp.c_str(), ios::app);
            if(StrategyParam::orForCompition)
                *FileOp::ofProofComp << FileOp::judgeOriginalFileName + " :TMO‑Non" << endl;
            else
                *FileOp::ofProofComp << FileOp::JudgeFileFullNameNoExt + " :TMO‑Non" << endl;
            FileOp::ofProofComp->close();
        }
          delRecord1data2->close();
    }
  
    
    //to geoff test
    //if(0){
       // FileOp::delRunFiles();
   // }
    
    
    //FileOp::ReleaseOf();
    fol.DelSet();//20170807
    return rst;
}
